function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React, { Component } from 'react';
import { connect } from 'react-redux';
import CircularProgress from '@material-ui/core/CircularProgress';
import { setInitialData as _setInitialData, setPredefinedValues as _setPredefinedValues, setUsers as _setUsers, setPredefinedEndpoint as _setPredefinedEndpoint, setFileUploadUrl as _setFileUploadUrl, setOrder as _setOrder, setConditionableFields as _setConditionableFields, createField as _createField, setLocals as _setLocals, setFormId as _setFormId, setTheme as _setTheme, setCurrentLang as _setCurrentLang, setRoles as _setRoles, setAllRoles as _setAllRoles } from '../../actions/formActions';
import MainLayout from '../../layouts/Main';
import predefined from '../../predefined-values';
import './App.scss';
import _ from 'lodash';
import axios from 'axios';
import Wrapper from './FieldWrapper';
import DroppableField from './DroppableField';
import { Scrollbars } from 'react-custom-scrollbars';
import { getHeight, generateSampleData } from '../../utils/helpers';
var noFieldMessage = {
  en: 'Looks like there are no fields in this form',
  ar: 'يبدو أنه لا توجد حقول في هذا النموذج'
};
var compare = function compare(a, b) {
  if (a.order < b.order) {
    return -1;
  }
  if (a.order > b.order) {
    return 1;
  }
  return 0;
};
var App = /*#__PURE__*/function (_Component) {
  function App(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _defineProperty(_this, "handleOnDragStart", function (index) {
      _this.onDragItem = index;
      _this.setState(_extends({}, _this.state, {
        onDragExisitingField: true
      }));
    });
    _defineProperty(_this, "handleOnDrop", function (index, type, uuid, order, event, callback) {
      event.stopPropagation();
      var droppedFieldSlug = event.dataTransfer.getData('droppedFieldSlug');
      if (droppedFieldSlug) {
        if (type === 'section' && droppedFieldSlug !== 'section') {
          var data = generateSampleData(droppedFieldSlug, order);
          data.parentId = uuid;
          _this.props.createField(data);
        }
      } else {
        _this.onDropItem = index;
        _this.reorderFields(_this.onDragItem, _this.onDropItem);
        callback ? callback() : null;
        _this.setState(_extends({}, _this.state, {
          onDragExisitingField: false
        }));
      }
    });
    _defineProperty(_this, "handleFieldDrop", function (e) {
      e.preventDefault();
      var droppedFieldSlug = e.dataTransfer.getData('droppedFieldSlug');
      if (droppedFieldSlug) {
        var data = generateSampleData(droppedFieldSlug, _this.props.order);
        _this.props.createField(data);
      }
    });
    _defineProperty(_this, "handleFieldDropBtw", function (e, order, callback) {
      e.stopPropagation();
      var droppedFieldSlug = e.dataTransfer.getData('droppedFieldSlug');
      if (droppedFieldSlug) {
        var data = generateSampleData(droppedFieldSlug, order);
        _this.props.createField(data);
      }
      callback();
    });
    _defineProperty(_this, "renderFields", function () {
      //  this.fields  = this.fields.filter(field =>{
      //   if(field.parentId) return false;
      //   return true;
      // })
      var count = 0;
      var total = _this.fields.length;
      return _.map(_this.fields, function (field, index) {
        count++;
        var droppableField = /*#__PURE__*/React.createElement(DroppableField, {
          onDrop: _this.handleFieldDropBtw,
          order: field.order
        });
        if (_this.state.onDragExisitingField) {
          droppableField = /*#__PURE__*/React.createElement(DroppableField, {
            onDragExisitingField: true,
            onDrop: _this.handleOnDrop,
            data: {
              index: index,
              field: field
            }
          });
        }
        if (count === total) {
          var lastDroppableField = /*#__PURE__*/React.createElement(DroppableField, {
            onDragExisitingField: true,
            onDrop: _this.handleOnDrop,
            data: {
              index: index + 1,
              field: field
            }
          });
          return [droppableField, /*#__PURE__*/React.createElement("div", {
            key: index,
            draggable: "true",
            onDragStart: function onDragStart() {
              return _this.handleOnDragStart(index);
            }
            // onDrop={(e) => this.handleOnDrop(index,field.type,field.uuid,field.order,e)}
            ,
            onDragOver: function onDragOver(event) {
              return event.preventDefault();
            }
          }, /*#__PURE__*/React.createElement("li", {
            key: 'li-' + field.uuid,
            className: "ahfb-d-block"
          }, /*#__PURE__*/React.createElement(Wrapper, {
            data: field,
            key: field.uuid,
            first: count === 1,
            last: count === total
          }))), lastDroppableField];
        }
        return [droppableField, /*#__PURE__*/React.createElement("div", {
          draggable: "true",
          onDragStart: function onDragStart() {
            return _this.handleOnDragStart(index);
          }
          // onDrop={(e) => this.handleOnDrop(index,field.type,field.uuid,field.order,e)}
          ,
          onDragOver: function onDragOver(event) {
            return event.preventDefault();
          }
        }, /*#__PURE__*/React.createElement("li", {
          key: 'li-' + field.uuid,
          className: "ahfb-d-block"
        }, /*#__PURE__*/React.createElement(Wrapper, {
          data: field,
          key: field.uuid,
          first: count === 1,
          last: count === total
        })))];
      });
    });
    _defineProperty(_this, "submitForm", function () {
      _this.props.onSubmit(_this.props.data);
    });
    _defineProperty(_this, "reorderFields", function (previousIndex, nextIndex) {
      if (previousIndex < nextIndex) {
        var _this$fields;
        var dragItem = _this.fields.splice(previousIndex, 1);
        console.log('sorting', dragItem, _this.fields);
        (_this$fields = _this.fields).splice.apply(_this$fields, [nextIndex - 1, 0].concat(dragItem));
        console.log('after slice', _this.fields);
      } else {
        var _this$fields2;
        console.log('before', _this.fields);
        var _dragItem = _this.fields.splice(previousIndex, 1);
        console.log('drag item', _dragItem);
        (_this$fields2 = _this.fields).splice.apply(_this$fields2, [nextIndex, 0].concat(_dragItem));
      }
      console.log('after sorting', _this.fields);
      var data = {};
      _this.fields.map(function (field, index) {
        // field.order = index + 1;
        data[field.uuid] = _extends({}, field, {
          order: index + 1
        });
      });
      _this.props.setInitialData(data);
    });
    _this.fields = {};
    _this.state = {
      loading: true,
      onDropExistingField: false
    };
    _this.onDragItem = null;
    _this.onDropItem = null;
    return _this;
  }
  _inheritsLoose(App, _Component);
  var _proto = App.prototype;
  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;
    if (this.props.conditionableFields) {
      this.props.setConditionableFields(this.props.conditionableFields);
    }
    if (_.size(this.props.formData)) {
      var order = 1;
      _.map(this.props.formData, function (field) {
        if (field.order > order) {
          order = field.order;
        }
      });
      this.props.setOrder(order + 1);
    }
    if (this.props.predefinedEndpoint) {
      axios.get(this.props.predefinedEndpoint).then(function (res) {
        _this2.props.setPredefinedValues(res.data);
        _this2.setState({
          loading: false
        }, function () {
          _this2.props.setPredefinedEndpoint(_this2.props.predefinedEndpoint);
          _this2.props.setRoles(_this2.props.roles);
          _this2.props.setAllRoles(_this2.props.allRoles);
          _this2.props.setFileUploadUrl(_this2.props.fileUploadUrl);
          _this2.props.setInitialData(_this2.props.formData);
          if (_this2.props.onDataLoaded) _this2.props.onDataLoaded();
        });
      })["catch"](function (err) {
        _this2.props.setPredefinedValues([]);
        _this2.setState({
          loading: false
        });
        console.error('Unable to fetch predefined options from ' + _this2.props.predefinedEndPoint);
      });
      axios.get(this.props.predefinedEndpoint + '/getAllUserEmail').then(function (res) {
        var _res$data;
        _this2.props.setUsers(res == null ? void 0 : (_res$data = res.data) == null ? void 0 : _res$data.users);
      });
    }
    if (this.props.locals) {
      this.props.setLocals(this.props.locals);
    }
    if (this.props.formId) {
      this.props.setFormId(this.props.formId);
    }
    if (this.props.theme) {
      this.props.setTheme(this.props.theme);
    }
    if (this.props.currentLang) {
      this.props.setCurrentLang(this.props.currentLang);
    }
    this.props.initializeSubmit(this.submitForm);
  };
  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    if (prevProps.theme.direction !== this.props.theme.direction) {
      this.props.setTheme(this.props.theme);
    }
  };
  _proto.render = function render() {
    var _this3 = this;
    if (this.state.loading) {
      return /*#__PURE__*/React.createElement(MainLayout, null, /*#__PURE__*/React.createElement("div", {
        className: "ahfb-width-full ahfb-text-center ahfb-pt-5"
      }, /*#__PURE__*/React.createElement(CircularProgress, {
        color: "secondary"
      })));
    }
    if (_.size(this.props.data) > 0) {
      this.fields = Object.values(this.props.data);
      this.fields.sort(compare);
      return /*#__PURE__*/React.createElement(MainLayout, null, /*#__PURE__*/React.createElement("div", {
        className: "ahfb-content-pane-main ahfb-position-relative",
        onDragOver: function onDragOver(e) {
          return e.preventDefault();
        },
        onDrop: function onDrop(e) {
          return _this3.handleFieldDrop(e);
        }
      }, /*#__PURE__*/React.createElement(Scrollbars, {
        style: {
          height: getHeight()
        },
        hideTracksWhenNotNeeded: true,
        autoHide: true
      }, this.renderFields()), /*#__PURE__*/React.createElement("div", {
        className: "ahfb-width-full ahfb-p-2"
      })));
    } else {
      return /*#__PURE__*/React.createElement(MainLayout, null, /*#__PURE__*/React.createElement("div", {
        className: "ahfb-content-pane-main ahfb-droppable-border",
        style: {
          height: getHeight()
        },
        onDragOver: function onDragOver(e) {
          return e.preventDefault();
        },
        onDrop: function onDrop(e) {
          return _this3.handleFieldDrop(e);
        }
      }, /*#__PURE__*/React.createElement("p", {
        className: "ahfb-pt-5 ahfb-text-center ahfb-text-muted"
      }, noFieldMessage[this.props.currentLang])));
    }
  };
  return App;
}(Component);
var mapStateToProps = function mapStateToProps(state) {
  return {
    data: state.form.data,
    order: state.form.order
  };
};
var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    setPredefinedValues: function setPredefinedValues(data) {
      return dispatch(_setPredefinedValues(data));
    },
    setUsers: function setUsers(data) {
      return dispatch(_setUsers(data));
    },
    setRoles: function setRoles(data) {
      return dispatch(_setRoles(data));
    },
    setAllRoles: function setAllRoles(data) {
      return dispatch(_setAllRoles(data));
    },
    setPredefinedEndpoint: function setPredefinedEndpoint(data) {
      return dispatch(_setPredefinedEndpoint(data));
    },
    setFileUploadUrl: function setFileUploadUrl(data) {
      return dispatch(_setFileUploadUrl(data));
    },
    setInitialData: function setInitialData(data) {
      return dispatch(_setInitialData(data));
    },
    setConditionableFields: function setConditionableFields(data) {
      return dispatch(_setConditionableFields(data));
    },
    setOrder: function setOrder(data) {
      return dispatch(_setOrder(data));
    },
    createField: function createField(data) {
      return dispatch(_createField(data));
    },
    setLocals: function setLocals(data) {
      return dispatch(_setLocals(data));
    },
    setFormId: function setFormId(data) {
      return dispatch(_setFormId(data));
    },
    setTheme: function setTheme(data) {
      return dispatch(_setTheme(data));
    },
    setCurrentLang: function setCurrentLang(data) {
      return dispatch(_setCurrentLang(data));
    }
  };
};
export default connect(mapStateToProps, mapDispatchToProps)(App);