function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React from 'react';
import Drawer from "./Drawer";
import Typography from '@material-ui/core/Typography';
import ListItem from '@material-ui/core/ListItem';
import Icon from './icons';
import config from '../../config';
import './styles.scss';
import { generateSampleData } from "../../utils/helpers";
import { connect } from "react-redux";
import { enableFieldEdit as _enableFieldEdit } from "../../actions/toolbarActions";
import { createField as _createField, setOrder as _setOrder } from '../../actions/formActions';
import EditField from "./EditField";
import { Grid } from '@material-ui/core';
var titleLabel = {
  en: 'Question Types',
  ar: 'أنواع الأسئلة'
};
var fields = [{
  label: {
    en: 'Text Field',
    ar: 'حقل نصّي'
  },
  slug: 'text',
  'icon': /*#__PURE__*/React.createElement(Icon, {
    name: "text"
  })
}, {
  label: {
    en: 'Select / Dropdown',
    ar: 'حدد / منسدلة'
  },
  slug: 'select',
  'icon': /*#__PURE__*/React.createElement(Icon, {
    name: "select"
  })
}, {
  label: {
    en: 'Checkbox Group',
    ar: 'مجموعة خانات الاختيار'
  },
  slug: 'checkbox',
  'icon': /*#__PURE__*/React.createElement(Icon, {
    name: "checkbox"
  })
}, {
  label: {
    en: 'Radio Group',
    ar: 'مجموعة راديو'
  },
  slug: 'radio',
  'icon': /*#__PURE__*/React.createElement(Icon, {
    name: "checkbox"
  })
}, {
  label: {
    en: 'Date Field',
    ar: 'حقل التاريخ'
  },
  slug: 'date',
  'icon': /*#__PURE__*/React.createElement(Icon, {
    name: "date"
  })
}, {
  label: {
    en: 'Content',
    ar: 'المحتوى'
  },
  slug: 'content',
  'icon': /*#__PURE__*/React.createElement(Icon, {
    name: "content"
  })
}, {
  label: {
    en: 'File Upload',
    ar: 'تحميل الملف'
  },
  slug: 'file',
  'icon': /*#__PURE__*/React.createElement(Icon, {
    name: "file-upload"
  })
}, {
  label: {
    en: 'Quiz',
    ar: 'Quiz'
  },
  slug: 'quiz',
  'icon': /*#__PURE__*/React.createElement(Icon, {
    name: "quiz"
  })
}, {
  label: {
    en: 'Survey',
    ar: 'Survey'
  },
  slug: 'survey',
  'icon': /*#__PURE__*/React.createElement(Icon, {
    name: "survey"
  })
}, {
  label: {
    en: 'List',
    ar: 'List'
  },
  slug: 'list',
  'icon': /*#__PURE__*/React.createElement(Icon, {
    name: "list"
  })
}, {
  label: {
    en: 'E-Signature',
    ar: 'التوقيع الإلكتروني'
  },
  slug: 'signature',
  'icon': /*#__PURE__*/React.createElement(Icon, {
    name: "signature"
  })
}, {
  label: {
    en: 'Image',
    ar: 'صورة'
  },
  slug: 'image',
  'icon': /*#__PURE__*/React.createElement(Icon, {
    name: "image"
  })
}, {
  label: {
    en: 'Video',
    ar: 'فيديو'
  },
  slug: 'video',
  'icon': /*#__PURE__*/React.createElement(Icon, {
    name: "video"
  })
}, {
  label: {
    en: 'Section',
    ar: 'Section'
  },
  slug: 'section',
  'icon': /*#__PURE__*/React.createElement(Icon, {
    name: "section"
  })
}];
var App = /*#__PURE__*/function (_React$Component) {
  function App() {
    var _this;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _defineProperty(_this, "addNewField", function (slug) {
      var data = generateSampleData(slug, _this.props.order);
      _this.props.createField(data);
    });
    _defineProperty(_this, "onDragStart", function (e, slug) {
      e.dataTransfer.setData("droppedFieldSlug", slug);
    });
    _defineProperty(_this, "onDragEnd", function (e) {
      e.dataTransfer.setData("droppedFieldSlug", null);
    });
    _defineProperty(_this, "renderFieldItems", function () {
      var count = -1;
      return fields.map(function (field, index) {
        if (config.hiddenFields.indexOf(field.slug) === -1) {
          count++;
          return /*#__PURE__*/React.createElement(Grid, {
            item: true,
            md: 6,
            xs: 12,
            className: count % 2 === 0 ? "ahfb-pt-3 ahfb-pr-1" : "ahfb-pt-3 ahfb-pl-1",
            key: 'field-' + field.slug,
            onDragStart: function onDragStart(e) {
              return _this.onDragStart(e, field.slug);
            },
            onDragOver: function onDragOver(e) {
              return e.preventDefault();
            },
            onDragEnd: function onDragEnd(e) {
              return _this.onDragEnd(e);
            }
          }, /*#__PURE__*/React.createElement(ListItem, {
            button: true,
            className: "ahfb-p-0"
          }, /*#__PURE__*/React.createElement("div", {
            className: "ahfb-field-type-container ahfb-pt-3 ahfb-cursor-pointer",
            onDoubleClick: function onDoubleClick(e) {
              return _this.addNewField(field.slug);
            },
            draggable: "true",
            onDragStart: function onDragStart(e) {
              return _this.onDragStart(e, field.slug);
            },
            onDragOver: function onDragOver(e) {
              return e.preventDefault();
            }
          }, field.icon, /*#__PURE__*/React.createElement(Typography, {
            variant: "subtitle1",
            gutterBottom: true
          }, field.label[_this.props.currentLang]))));
        }
        return '';
      });
    });
    return _this;
  }
  _inheritsLoose(App, _React$Component);
  var _proto = App.prototype;
  _proto.render = function render() {
    if (this.props.editId || this.props.newFieldData) {
      return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Drawer, {
        title: titleLabel[this.props.currentLang]
      }, /*#__PURE__*/React.createElement("div", {
        className: "ahfb-m-0"
      }, /*#__PURE__*/React.createElement(EditField, null))));
    }
    return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Drawer, {
      title: titleLabel[this.props.currentLang],
      type: "fields"
    }, /*#__PURE__*/React.createElement(Grid, {
      container: true,
      className: "ahfb-p-2"
    }, this.renderFieldItems())));
  };
  return App;
}(React.Component);
var mapStateToProps = function mapStateToProps(state) {
  return {
    newFieldData: state.form.newFieldData,
    editId: state.toolbar.editId,
    data: state.form.data,
    order: state.form.order,
    currentLang: state.form.currentLang
  };
};
var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    enableFieldEdit: function enableFieldEdit(id, operation) {
      return dispatch(_enableFieldEdit(id, operation));
    },
    createField: function createField(data) {
      return dispatch(_createField(data));
    },
    setOrder: function setOrder(data) {
      return dispatch(_setOrder(data));
    }
  };
};
export default connect(mapStateToProps, mapDispatchToProps)(App);