var _excluded = ["fieldConfigs", "locals", "handleDataChange"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React from 'react';
import _ from 'lodash';
import { FIELD_TYPES } from '../../../../utils/Globals';
import Checkbox from '../../../../utils/checkboxs/Checkbox';
import SearchableSelect from '../../../../utils/selects/SearchableSelect';
import TextInput from '../../../../utils/inputs/TextInput';
import { connect } from "react-redux";
var FieldRenderer = /*#__PURE__*/function (_React$Component) {
  function FieldRenderer() {
    var _this;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _defineProperty(_this, "renderLocalFields", function (field, key) {
      var _this$props = _this.props,
        locals = _this$props.locals,
        addLanguageSelect = _this$props.addLanguageSelect,
        currentLang = _this$props.currentLang;
      if (field && locals && locals.length && field.isTranslatable) {
        return locals.reduce(function (arr, local) {
          if (local.key === addLanguageSelect) {
            var newField = _.cloneDeep(field);
            newField.configs.label = {
              en: field.configs.label[currentLang] + " " + local.name,
              ar: field.configs.label[currentLang] + " " + local.name
            };
            newField.configs.required = false;
            newField.configs.autoFocus = false;
            arr.push(_this.renderField(newField, key + "_" + local.key, true));
          }
          return arr;
        }, []);
      }
    });
    _defineProperty(_this, "renderField", function (field, key) {
      var _field$configs, _field$configs2, _field$configs3;
      var _this$props2 = _this.props,
        fieldConfigs = _this$props2.fieldConfigs,
        locals = _this$props2.locals,
        handleDataChange = _this$props2.handleDataChange,
        rest = _objectWithoutPropertiesLoose(_this$props2, _excluded);
      var error = false;
      if (field.error && key in rest.errors) error = rest.errors[key];
      switch (field.type) {
        case FIELD_TYPES.CHECKBOX:
          return !(field != null && (_field$configs = field.configs) != null && _field$configs.hidden) && /*#__PURE__*/React.createElement("div", {
            key: key,
            className: "ahfb-mb-4"
          }, /*#__PURE__*/React.createElement(Checkbox, _extends({}, field.configs, {
            label: field.configs.label[_this.props.currentLang],
            checked: rest[key],
            value: rest[key],
            handleChange: function handleChange(val) {
              return handleDataChange(val, key);
            },
            error: error
          })));
        case FIELD_TYPES.SEARCHABLE_SELECT:
          var formattedData = [];
          _.map(field.configs.options, function (row) {
            var formattedObj = {};
            formattedObj.value = row.value;
            formattedObj.label = row.label[_this.props.currentLang];
            formattedData.push(formattedObj);
          });
          return !(field != null && (_field$configs2 = field.configs) != null && _field$configs2.hidden) && /*#__PURE__*/React.createElement("div", {
            key: key,
            className: "ahfb-mb-4"
          }, /*#__PURE__*/React.createElement(SearchableSelect, _extends({}, field.configs, {
            label: field.configs.label[_this.props.currentLang],
            value: rest[key],
            handleChange: function handleChange(e) {
              return handleDataChange(e.target.value, key);
            },
            error: error,
            options: formattedData
          })));
        case FIELD_TYPES.TEXT:
          return !(field != null && (_field$configs3 = field.configs) != null && _field$configs3.hidden) && /*#__PURE__*/React.createElement(React.Fragment, {
            key: key
          }, /*#__PURE__*/React.createElement("div", {
            className: "ahfb-mb-4"
          }, /*#__PURE__*/React.createElement(TextInput, _extends({}, field.configs, {
            label: field.configs.label[_this.props.currentLang],
            value: rest[key],
            handleChange: function handleChange(e) {
              return handleDataChange(e.target.value, key);
            },
            error: error
          }))));
      }
    });
    return _this;
  }
  _inheritsLoose(FieldRenderer, _React$Component);
  var _proto = FieldRenderer.prototype;
  _proto.render = function render() {
    var _this2 = this;
    var fieldConfigs = this.props.fieldConfigs;
    return /*#__PURE__*/React.createElement("div", null, fieldConfigs && Object.keys(fieldConfigs).map(function (key) {
      return /*#__PURE__*/React.createElement(React.Fragment, {
        key: key
      }, _this2.renderField(fieldConfigs[key], key), fieldConfigs[key].isTranslatable && _this2.renderLocalFields(fieldConfigs[key], key));
    }));
  };
  return FieldRenderer;
}(React.Component);
var mapStateToProps = function mapStateToProps(state) {
  return {
    locals: state.form.locals,
    addLanguageSelect: state.form.addLanguageSelect,
    currentLang: state.form.currentLang
  };
};
export default connect(mapStateToProps, null)(FieldRenderer);