import React from 'react';
import { FormLabel, FormControl, FormHelperText } from '@material-ui/core';
import { makeStyles } from '@material-ui/core/styles';
import EmailComplete from '../../utils/selects/EmailComplete';
import InputLabel from "@material-ui/core/InputLabel";
var useStyles = makeStyles(function (theme) {
  return {
    labelRoot: {
      transform: 'none'
    }
  };
});
export default function EmailSelects(props) {
  var sendTo = props.sendTo,
    sendToExternal = props.sendToExternal,
    cc = props.cc,
    ccExternal = props.ccExternal,
    bcc = props.bcc,
    bccExternal = props.bccExternal,
    handleChange = props.handleChange,
    roles = props.roles,
    error = props.error,
    required = props.required;
  var classes = useStyles();
  return /*#__PURE__*/React.createElement("div", {
    className: "w-full"
  }, /*#__PURE__*/React.createElement(FormControl, {
    className: "p-16",
    fullWidth: true
  }, /*#__PURE__*/React.createElement("label", {
    required: required,
    shrink: true,
    classes: {
      shrink: classes.labelRoot
    },
    className: "ahfb-mt-2 ahfb-mb-2 ahfb-align-center"
  }, "Recipients"), /*#__PURE__*/React.createElement(EmailComplete, {
    placeholder: 'Please select recipient(s)',
    internal: sendTo,
    external: sendToExternal,
    onChange: function onChange(internal, external) {
      return handleChange('send_to', internal, external);
    },
    data: roles,
    id: "recipient",
    includeSelectAll: false
  }), error && /*#__PURE__*/React.createElement(FormHelperText, {
    error: true
  }, error)), /*#__PURE__*/React.createElement(FormControl, {
    className: "p-16",
    fullWidth: true
  }, /*#__PURE__*/React.createElement("label", {
    required: required,
    shrink: true,
    classes: {
      shrink: classes.labelRoot
    },
    className: "ahfb-mt-2 ahfb-mb-2 ahfb-align-center"
  }, "CC"), /*#__PURE__*/React.createElement(EmailComplete, {
    placeholder: 'Please select cc(s)',
    internal: cc,
    external: ccExternal,
    onChange: function onChange(internal, external) {
      return handleChange('cc', internal, external);
    },
    data: roles,
    id: "cc",
    includeSelectAll: false
  })), /*#__PURE__*/React.createElement(FormControl, {
    className: "p-16",
    fullWidth: true
  }, /*#__PURE__*/React.createElement("label", {
    required: required,
    shrink: true,
    classes: {
      shrink: classes.labelRoot
    },
    className: "ahfb-mt-2 ahfb-mb-2 ahfb-align-center"
  }, "BCC"), /*#__PURE__*/React.createElement(EmailComplete, {
    placeholder: 'Please select bcc(s)',
    internal: bcc,
    external: bccExternal,
    onChange: function onChange(internal, external) {
      return handleChange('bcc', internal, external);
    },
    data: roles,
    id: "cc",
    includeSelectAll: false
  })));
}