"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactRedux = require("react-redux");
var _CircularProgress = _interopRequireDefault(require("@material-ui/core/CircularProgress"));
var _formActions = require("../../actions/formActions");
var _Main = _interopRequireDefault(require("../../layouts/Main"));
var _predefinedValues = _interopRequireDefault(require("../../predefined-values"));
require("./App.scss");
var _lodash = _interopRequireDefault(require("lodash"));
var _axios = _interopRequireDefault(require("axios"));
var _FieldWrapper = _interopRequireDefault(require("./FieldWrapper"));
var _DroppableField = _interopRequireDefault(require("./DroppableField"));
var _reactCustomScrollbars = require("react-custom-scrollbars");
var _helpers = require("../../utils/helpers");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var noFieldMessage = {
  en: 'Looks like there are no fields in this form',
  ar: 'يبدو أنه لا توجد حقول في هذا النموذج'
};
var compare = function compare(a, b) {
  if (a.order < b.order) {
    return -1;
  }
  if (a.order > b.order) {
    return 1;
  }
  return 0;
};
var App = /*#__PURE__*/function (_Component) {
  function App(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _defineProperty(_this, "handleOnDragStart", function (index) {
      _this.onDragItem = index;
      _this.setState(_extends({}, _this.state, {
        onDragExisitingField: true
      }));
    });
    _defineProperty(_this, "handleOnDrop", function (index, type, uuid, order, event, callback) {
      event.stopPropagation();
      var droppedFieldSlug = event.dataTransfer.getData('droppedFieldSlug');
      if (droppedFieldSlug) {
        if (type === 'section' && droppedFieldSlug !== 'section') {
          var data = (0, _helpers.generateSampleData)(droppedFieldSlug, order);
          data.parentId = uuid;
          _this.props.createField(data);
        }
      } else {
        _this.onDropItem = index;
        _this.reorderFields(_this.onDragItem, _this.onDropItem);
        callback ? callback() : null;
        _this.setState(_extends({}, _this.state, {
          onDragExisitingField: false
        }));
      }
    });
    _defineProperty(_this, "handleFieldDrop", function (e) {
      e.preventDefault();
      var droppedFieldSlug = e.dataTransfer.getData('droppedFieldSlug');
      if (droppedFieldSlug) {
        var data = (0, _helpers.generateSampleData)(droppedFieldSlug, _this.props.order);
        _this.props.createField(data);
      }
    });
    _defineProperty(_this, "handleFieldDropBtw", function (e, order, callback) {
      e.stopPropagation();
      var droppedFieldSlug = e.dataTransfer.getData('droppedFieldSlug');
      if (droppedFieldSlug) {
        var data = (0, _helpers.generateSampleData)(droppedFieldSlug, order);
        _this.props.createField(data);
      }
      callback();
    });
    _defineProperty(_this, "renderFields", function () {
      //  this.fields  = this.fields.filter(field =>{
      //   if(field.parentId) return false;
      //   return true;
      // })
      var count = 0;
      var total = _this.fields.length;
      return _lodash["default"].map(_this.fields, function (field, index) {
        count++;
        var droppableField = /*#__PURE__*/_react["default"].createElement(_DroppableField["default"], {
          onDrop: _this.handleFieldDropBtw,
          order: field.order
        });
        if (_this.state.onDragExisitingField) {
          droppableField = /*#__PURE__*/_react["default"].createElement(_DroppableField["default"], {
            onDragExisitingField: true,
            onDrop: _this.handleOnDrop,
            data: {
              index: index,
              field: field
            }
          });
        }
        if (count === total) {
          var lastDroppableField = /*#__PURE__*/_react["default"].createElement(_DroppableField["default"], {
            onDragExisitingField: true,
            onDrop: _this.handleOnDrop,
            data: {
              index: index + 1,
              field: field
            }
          });
          return [droppableField, /*#__PURE__*/_react["default"].createElement("div", {
            key: index,
            draggable: "true",
            onDragStart: function onDragStart() {
              return _this.handleOnDragStart(index);
            }
            // onDrop={(e) => this.handleOnDrop(index,field.type,field.uuid,field.order,e)}
            ,
            onDragOver: function onDragOver(event) {
              return event.preventDefault();
            }
          }, /*#__PURE__*/_react["default"].createElement("li", {
            key: 'li-' + field.uuid,
            className: "ahfb-d-block"
          }, /*#__PURE__*/_react["default"].createElement(_FieldWrapper["default"], {
            data: field,
            key: field.uuid,
            first: count === 1,
            last: count === total
          }))), lastDroppableField];
        }
        return [droppableField, /*#__PURE__*/_react["default"].createElement("div", {
          draggable: "true",
          onDragStart: function onDragStart() {
            return _this.handleOnDragStart(index);
          }
          // onDrop={(e) => this.handleOnDrop(index,field.type,field.uuid,field.order,e)}
          ,
          onDragOver: function onDragOver(event) {
            return event.preventDefault();
          }
        }, /*#__PURE__*/_react["default"].createElement("li", {
          key: 'li-' + field.uuid,
          className: "ahfb-d-block"
        }, /*#__PURE__*/_react["default"].createElement(_FieldWrapper["default"], {
          data: field,
          key: field.uuid,
          first: count === 1,
          last: count === total
        })))];
      });
    });
    _defineProperty(_this, "submitForm", function () {
      _this.props.onSubmit(_this.props.data);
    });
    _defineProperty(_this, "reorderFields", function (previousIndex, nextIndex) {
      if (previousIndex < nextIndex) {
        var _this$fields;
        var dragItem = _this.fields.splice(previousIndex, 1);
        console.log('sorting', dragItem, _this.fields);
        (_this$fields = _this.fields).splice.apply(_this$fields, [nextIndex - 1, 0].concat(dragItem));
        console.log('after slice', _this.fields);
      } else {
        var _this$fields2;
        console.log('before', _this.fields);
        var _dragItem = _this.fields.splice(previousIndex, 1);
        console.log('drag item', _dragItem);
        (_this$fields2 = _this.fields).splice.apply(_this$fields2, [nextIndex, 0].concat(_dragItem));
      }
      console.log('after sorting', _this.fields);
      var data = {};
      _this.fields.map(function (field, index) {
        // field.order = index + 1;
        data[field.uuid] = _extends({}, field, {
          order: index + 1
        });
      });
      _this.props.setInitialData(data);
    });
    _this.fields = {};
    _this.state = {
      loading: true,
      onDropExistingField: false
    };
    _this.onDragItem = null;
    _this.onDropItem = null;
    return _this;
  }
  _inheritsLoose(App, _Component);
  var _proto = App.prototype;
  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;
    if (this.props.conditionableFields) {
      this.props.setConditionableFields(this.props.conditionableFields);
    }
    if (_lodash["default"].size(this.props.formData)) {
      var order = 1;
      _lodash["default"].map(this.props.formData, function (field) {
        if (field.order > order) {
          order = field.order;
        }
      });
      this.props.setOrder(order + 1);
    }
    if (this.props.predefinedEndpoint) {
      _axios["default"].get(this.props.predefinedEndpoint).then(function (res) {
        _this2.props.setPredefinedValues(res.data);
        _this2.setState({
          loading: false
        }, function () {
          _this2.props.setPredefinedEndpoint(_this2.props.predefinedEndpoint);
          _this2.props.setRoles(_this2.props.roles);
          _this2.props.setAllRoles(_this2.props.allRoles);
          _this2.props.setFileUploadUrl(_this2.props.fileUploadUrl);
          _this2.props.setInitialData(_this2.props.formData);
          if (_this2.props.onDataLoaded) _this2.props.onDataLoaded();
        });
      })["catch"](function (err) {
        _this2.props.setPredefinedValues([]);
        _this2.setState({
          loading: false
        });
        console.error('Unable to fetch predefined options from ' + _this2.props.predefinedEndPoint);
      });
      _axios["default"].get(this.props.predefinedEndpoint + '/getAllUserEmail').then(function (res) {
        var _res$data;
        _this2.props.setUsers(res == null ? void 0 : (_res$data = res.data) == null ? void 0 : _res$data.users);
      });
    }
    if (this.props.locals) {
      this.props.setLocals(this.props.locals);
    }
    if (this.props.formId) {
      this.props.setFormId(this.props.formId);
    }
    if (this.props.theme) {
      this.props.setTheme(this.props.theme);
    }
    if (this.props.currentLang) {
      this.props.setCurrentLang(this.props.currentLang);
    }
    this.props.initializeSubmit(this.submitForm);
  };
  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    if (prevProps.theme.direction !== this.props.theme.direction) {
      this.props.setTheme(this.props.theme);
    }
  };
  _proto.render = function render() {
    var _this3 = this;
    if (this.state.loading) {
      return /*#__PURE__*/_react["default"].createElement(_Main["default"], null, /*#__PURE__*/_react["default"].createElement("div", {
        className: "ahfb-width-full ahfb-text-center ahfb-pt-5"
      }, /*#__PURE__*/_react["default"].createElement(_CircularProgress["default"], {
        color: "secondary"
      })));
    }
    if (_lodash["default"].size(this.props.data) > 0) {
      this.fields = Object.values(this.props.data);
      this.fields.sort(compare);
      return /*#__PURE__*/_react["default"].createElement(_Main["default"], null, /*#__PURE__*/_react["default"].createElement("div", {
        className: "ahfb-content-pane-main ahfb-position-relative",
        onDragOver: function onDragOver(e) {
          return e.preventDefault();
        },
        onDrop: function onDrop(e) {
          return _this3.handleFieldDrop(e);
        }
      }, /*#__PURE__*/_react["default"].createElement(_reactCustomScrollbars.Scrollbars, {
        style: {
          height: (0, _helpers.getHeight)()
        },
        hideTracksWhenNotNeeded: true,
        autoHide: true
      }, this.renderFields()), /*#__PURE__*/_react["default"].createElement("div", {
        className: "ahfb-width-full ahfb-p-2"
      })));
    } else {
      return /*#__PURE__*/_react["default"].createElement(_Main["default"], null, /*#__PURE__*/_react["default"].createElement("div", {
        className: "ahfb-content-pane-main ahfb-droppable-border",
        style: {
          height: (0, _helpers.getHeight)()
        },
        onDragOver: function onDragOver(e) {
          return e.preventDefault();
        },
        onDrop: function onDrop(e) {
          return _this3.handleFieldDrop(e);
        }
      }, /*#__PURE__*/_react["default"].createElement("p", {
        className: "ahfb-pt-5 ahfb-text-center ahfb-text-muted"
      }, noFieldMessage[this.props.currentLang])));
    }
  };
  return App;
}(_react.Component);
var mapStateToProps = function mapStateToProps(state) {
  return {
    data: state.form.data,
    order: state.form.order
  };
};
var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    setPredefinedValues: function setPredefinedValues(data) {
      return dispatch((0, _formActions.setPredefinedValues)(data));
    },
    setUsers: function setUsers(data) {
      return dispatch((0, _formActions.setUsers)(data));
    },
    setRoles: function setRoles(data) {
      return dispatch((0, _formActions.setRoles)(data));
    },
    setAllRoles: function setAllRoles(data) {
      return dispatch((0, _formActions.setAllRoles)(data));
    },
    setPredefinedEndpoint: function setPredefinedEndpoint(data) {
      return dispatch((0, _formActions.setPredefinedEndpoint)(data));
    },
    setFileUploadUrl: function setFileUploadUrl(data) {
      return dispatch((0, _formActions.setFileUploadUrl)(data));
    },
    setInitialData: function setInitialData(data) {
      return dispatch((0, _formActions.setInitialData)(data));
    },
    setConditionableFields: function setConditionableFields(data) {
      return dispatch((0, _formActions.setConditionableFields)(data));
    },
    setOrder: function setOrder(data) {
      return dispatch((0, _formActions.setOrder)(data));
    },
    createField: function createField(data) {
      return dispatch((0, _formActions.createField)(data));
    },
    setLocals: function setLocals(data) {
      return dispatch((0, _formActions.setLocals)(data));
    },
    setFormId: function setFormId(data) {
      return dispatch((0, _formActions.setFormId)(data));
    },
    setTheme: function setTheme(data) {
      return dispatch((0, _formActions.setTheme)(data));
    },
    setCurrentLang: function setCurrentLang(data) {
      return dispatch((0, _formActions.setCurrentLang)(data));
    }
  };
};
var _default = exports["default"] = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(App);
module.exports = exports.default;