"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _formActions = require("../../actions/formActions");
var _toolbarActions = require("../../actions/toolbarActions");
var _reactRedux = require("react-redux");
var _Input = _interopRequireDefault(require("./fields-wrappers/Input"));
var _Delete = _interopRequireDefault(require("@material-ui/icons/Delete"));
var _FileCopy = _interopRequireDefault(require("@material-ui/icons/FileCopy"));
var _Edit = _interopRequireDefault(require("@material-ui/icons/Edit"));
var _core = require("@material-ui/core");
var _Select = _interopRequireDefault(require("./fields-wrappers/Select"));
var _ButtonGroup = _interopRequireDefault(require("@material-ui/core/ButtonGroup"));
var _Button = _interopRequireDefault(require("@material-ui/core/Button"));
var _Checkbox = _interopRequireDefault(require("./fields-wrappers/Checkbox"));
var _Radio = _interopRequireDefault(require("./fields-wrappers/Radio"));
var _Date = _interopRequireDefault(require("./fields-wrappers/Date"));
var _Content = _interopRequireDefault(require("./fields-wrappers/Content"));
var _File = _interopRequireDefault(require("./fields-wrappers/File"));
var _Section = _interopRequireDefault(require("./fields-wrappers/Section"));
var _Signature = _interopRequireDefault(require("./fields-wrappers/Signature"));
var _Image = _interopRequireDefault(require("./fields-wrappers/Image"));
var _Video = _interopRequireDefault(require("./fields-wrappers/Video"));
var _helpers = require("../../utils/helpers");
var _useWindowSize2 = require("../hooks/useWindowSize");
var _lodash = _interopRequireDefault(require("lodash"));
var _axios = _interopRequireDefault(require("axios"));
var _predefinedActions = require("../../actions/predefinedActions");
var _AlertDialog = _interopRequireDefault(require("../../utils/alertdialog/AlertDialog"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == typeof h && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator["return"] && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(typeof e + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, "catch": function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function _asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function FieldWrapper(props) {
  var _React$useState = _react["default"].useState(false),
    options = _React$useState[0],
    setOptions = _React$useState[1];
  var _useWindowSize = (0, _useWindowSize2.useWindowSize)(),
    width = _useWindowSize.width;
  var _useState = (0, _react.useState)(false),
    openDelete = _useState[0],
    setOpenDelete = _useState[1];
  var _useState2 = (0, _react.useState)(false),
    deleteLoading = _useState2[0],
    setDeleteLoading = _useState2[1];
  var enableEdit = function enableEdit(e) {
    props.enableFieldEdit(props.data.uuid);
  };
  var removeField = function removeField(e) {
    setOpenDelete(true);
    // if (props.editId === props.data.uuid) {
    //   props.disableFieldEdit();
    // }
    // props.deleteField(props.data.uuid);
  };
  var cloneField = function cloneField(e) {
    var _newData$config;
    var uuid = (0, _helpers.generateUUID)();
    var machineName = props.data.type + "-" + (0, _helpers.getUniqueNumber)();
    var newData = _lodash["default"].cloneDeep(props.data);
    newData.uuid = uuid;
    newData.machineName = machineName;
    if (["checkbox", "select", "radio"].includes(newData == null ? void 0 : newData.type) && newData != null && (_newData$config = newData.config) != null && _newData$config.optionReferenceId) {
      var preDef = props.predefined.find(function (item) {
        var _newData$config2;
        return item.id === (newData == null ? void 0 : (_newData$config2 = newData.config) == null ? void 0 : _newData$config2.optionReferenceId);
      });
      var clonePredef = {
        id: (0, _helpers.getUniqueNumber)(),
        name: preDef.name + '_clone_' + (0, _helpers.getUniqueNumber)(),
        slug: preDef.slug + '_clone_' + (0, _helpers.getUniqueNumber)(),
        is_public: false,
        is_secure: false,
        isNew: true,
        options: preDef.options.map(function (item) {
          return _extends({}, item, {
            id: (0, _helpers.getUniqueNumber)()
          });
        })
      };
      props.addCategory(clonePredef);
      newData.config = _extends({}, newData.config, {
        optionReferenceId: clonePredef.id
      });
      props.createField(newData);
      // clone predefined
      // axios
      //   .post(`${props.predefinedEndpoint}/clone-option-reference`, {
      //     optionRefId: newData?.config?.optionReferenceId,
      //   })
      //   .then((res) => {
      //     props.addCategory(res.data.cloneOptionRef);
      //     newData.config = {
      //       ...newData.config,
      //       optionReferenceId: res.data.cloneOptionRef.id,
      //     };
      //     props.createField(newData);
      //   });
    } else {
      props.createField(newData);
    }
  };
  var showOptions = function showOptions() {
    setOptions(true);
  };
  var hideOptions = function hideOptions() {
    setOptions(false);
  };
  var renderFields = function renderFields(predefined) {
    switch (props.data.type) {
      case "text":
        return /*#__PURE__*/_react["default"].createElement(_Input["default"], {
          data: props.data,
          currentLang: props.currentLang
        });
      case "checkbox":
        return /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          data: props.data,
          predefined: predefined,
          currentLang: props.currentLang
        });
      case "radio":
        return /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
          data: props.data,
          predefined: predefined,
          currentLang: props.currentLang
        });
      case "select":
        return /*#__PURE__*/_react["default"].createElement(_Select["default"], {
          data: props.data,
          predefined: predefined,
          currentLang: props.currentLang
        });
      case "content":
        return /*#__PURE__*/_react["default"].createElement(_Content["default"], {
          data: props.data,
          currentLang: props.currentLang
        });
      case "date":
        return /*#__PURE__*/_react["default"].createElement(_Date["default"], {
          data: props.data,
          currentLang: props.currentLang
        });
      case "file":
        return /*#__PURE__*/_react["default"].createElement(_File["default"], {
          data: props.data,
          currentLang: props.currentLang
        });
      case "image":
        return /*#__PURE__*/_react["default"].createElement(_Image["default"], {
          data: props.data,
          currentLang: props.currentLang
        });
      case "list":
        return /*#__PURE__*/_react["default"].createElement("h1", null, "list");
      case "quiz":
        return /*#__PURE__*/_react["default"].createElement("h1", null, "quiz");
      case "signature":
        return /*#__PURE__*/_react["default"].createElement(_Signature["default"], {
          data: props.data,
          currentLang: props.currentLang
        });
      case "survey":
        return /*#__PURE__*/_react["default"].createElement("h1", null, "survey");
      case "video":
        return /*#__PURE__*/_react["default"].createElement(_Video["default"], {
          data: props.data,
          currentLang: props.currentLang
        });
      case "section":
        return /*#__PURE__*/_react["default"].createElement(_Section["default"], {
          data: props.data,
          currentLang: props.currentLang
        });
      default:
        return /*#__PURE__*/_react["default"].createElement("div", null, " Default ");
    }
  };
  var className = "wrapper ahfb-shadow-1 ahfb-bg-white ahfb-ml-3 ahfb-mr-3 ahfb-p-3 ahfb-relative";
  if (props.first) {
    className = className + " first-field";
  }
  if (props.last) {
    className = className + " last-field";
  }
  var predefined = {};
  props.predefined.map(function (item) {
    predefined[item.id] = item;
  });
  return /*#__PURE__*/_react["default"].createElement("div", null, props.data.name || props.data.type === "content" || props.data.type === "image" || props.data.type === "video" ? /*#__PURE__*/_react["default"].createElement("div", {
    className: className,
    onMouseOver: showOptions,
    onMouseLeave: hideOptions
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "innerWrapper",
    style: {
      marginTop: width < 450 ? "30px" : "25px"
    }
  }, options ? /*#__PURE__*/_react["default"].createElement(_ButtonGroup["default"], {
    className: "options-menu ahfb-absolute ahfb-" + (props.theme.direction ? props.theme.direction : "ltr") + "-1 ahfb-top-1 ahfb-float-right"
    // ahfb-zIndex  -> class remove
    ,
    size: "small",
    "aria-label": "outlined primary button group"
  }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    className: "delete-icon",
    onClick: removeField
  }, /*#__PURE__*/_react["default"].createElement(_Delete["default"], {
    fontSize: "small",
    color: "action"
  })), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    className: "edit-icon",
    onClick: enableEdit
  }, /*#__PURE__*/_react["default"].createElement(_Edit["default"], {
    fontSize: "small",
    color: "action"
  })), props.data.type !== "section" ? /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    className: "clone-icon",
    onClick: cloneField
  }, /*#__PURE__*/_react["default"].createElement(_core.Tooltip, {
    title: "Clone field"
  }, /*#__PURE__*/_react["default"].createElement(_FileCopy["default"], {
    fontSize: "small",
    color: "action"
  }))) : "") : "", renderFields(predefined)), /*#__PURE__*/_react["default"].createElement(_AlertDialog["default"], {
    open: openDelete,
    title: "Delete Field",
    message: "Are you sure you want to delete the Field?",
    primaryLabel: "Delete",
    primaryAction: /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            setDeleteLoading(true);
            _context.next = 3;
            return _axios["default"]["delete"](props.predefinedEndpoint + "/form/field/" + props.formId + "/" + props.data.uuid).then(function () {
              if (props.editId === props.data.uuid) {
                props.disableFieldEdit();
              }
              props.deleteField(props.data.uuid);
              setOpenDelete(false);
              setDeleteLoading(false);
            });
          case 3:
          case "end":
            return _context.stop();
        }
      }, _callee);
    })),
    primaryActionLoading: deleteLoading,
    secondaryLabel: "Cancel",
    secondaryAction: function secondaryAction() {
      setOpenDelete(false);
    }
  })) : "");
}
var mapStateToProps = function mapStateToProps(state) {
  return {
    editId: state.toolbar.editId,
    predefined: state.form.predefined,
    predefinedEndpoint: state.form.predefinedEndpoint,
    theme: state.form.theme,
    formId: state.form.formId,
    currentLang: state.form.currentLang
  };
};
var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    createField: function createField(id) {
      return dispatch((0, _formActions.createField)(id));
    },
    deleteField: function deleteField(id) {
      return dispatch((0, _formActions.deleteField)(id));
    },
    enableFieldEdit: function enableFieldEdit(id) {
      return dispatch((0, _toolbarActions.enableFieldEdit)(id));
    },
    disableFieldEdit: function disableFieldEdit() {
      return dispatch((0, _toolbarActions.disableFieldEdit)());
    },
    addCategory: function addCategory(id) {
      return dispatch((0, _predefinedActions.addCategory)(id));
    }
  };
};
var _default = exports["default"] = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(FieldWrapper);
module.exports = exports.default;