"use strict";

exports.__esModule = true;
exports["default"] = SelectWrapper;
var _react = _interopRequireDefault(require("react"));
var _TextInput = _interopRequireDefault(require("../../../utils/inputs/TextInput"));
var _MultiSelect = _interopRequireDefault(require("../../../utils/selects/MultiSelect"));
var _SearchableSelect = _interopRequireDefault(require("../../../utils/selects/SearchableSelect"));
var _CheckboxGroup = _interopRequireDefault(require("../../../utils/checkboxs/CheckboxGroup"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function SelectWrapper(props) {
  var _props$data, _props$data$config;
  var defaultValue = [];
  var _React$useState = _react["default"].useState(defaultValue),
    value = _React$useState[0],
    setValue = _React$useState[1];
  var _React$useState2 = _react["default"].useState(false),
    other = _React$useState2[0],
    setOther = _React$useState2[1];
  var _React$useState3 = _react["default"].useState(''),
    otherValue = _React$useState3[0],
    setOtherValue = _React$useState3[1];
  var handleChange = function handleChange(e) {
    var newValue = e.target.value;
    if (props.data.config.isMultiple && newValue.includes(-1)) {
      setOther(true);
    } else if (!props.data.config.isMultiple && newValue === -1) {
      setOther(true);
    } else {
      setOther(false);
      setOtherValue('');
    }
    setValue(newValue);
  };
  var handleOtherChange = function handleOtherChange(e) {
    setOtherValue(e.target.value);
  };
  var options = [];
  if (props != null && (_props$data = props.data) != null && (_props$data$config = _props$data.config) != null && _props$data$config.optionReferenceId) {
    var _props$predefined$pro, _props$data2, _props$data2$config;
    options = _.cloneDeep(props == null ? void 0 : (_props$predefined$pro = props.predefined[props == null ? void 0 : (_props$data2 = props.data) == null ? void 0 : (_props$data2$config = _props$data2.config) == null ? void 0 : _props$data2$config.optionReferenceId]) == null ? void 0 : _props$predefined$pro.options);
  }
  if (props.data.config.enableOther) {
    options.push({
      id: -1,
      name: 'Specify Others'
    });
  }
  if (props.data.config.isMultiple) {
    var _props$data4;
    if (other) {
      var _props$data3;
      return [/*#__PURE__*/_react["default"].createElement(_MultiSelect["default"], {
        label: (_props$data3 = props.data) != null && _props$data3.locals && Object.keys(props.data.locals).length !== 0 ? props.currentLang === 'en' ? props.data.name : props.data.locals.ar.name_ar : props.data.name,
        placeholder: props.data.config.placeholder,
        helperText: props.data.config.helpText,
        required: props.data.config.isRequired,
        options: options,
        value: value,
        labelProp: "name",
        valueProp: "id",
        handleChange: handleChange
      }), /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
        handleChange: handleOtherChange,
        value: otherValue,
        placeholder: "Specify Others"
      })];
    }
    return /*#__PURE__*/_react["default"].createElement(_MultiSelect["default"], {
      label: (_props$data4 = props.data) != null && _props$data4.locals && Object.keys(props.data.locals).length !== 0 ? props.currentLang === 'en' ? props.data.name : props.data.locals.ar.name_ar : props.data.name,
      placeholder: props.data.config.placeholder,
      helperText: props.data.config.helpText,
      required: props.data.config.isRequired,
      options: options,
      value: value,
      labelProp: "name",
      valueProp: "id",
      handleChange: handleChange
    });
  } else {
    if (other) {
      return [/*#__PURE__*/_react["default"].createElement(_SearchableSelect["default"], {
        label: props.data.name,
        placeholder: props.data.config.placeholder,
        helperText: props.data.config.helpText,
        required: props.data.config.isRequired,
        labelProp: "name",
        valueProp: "id",
        options: options,
        value: value,
        handleChange: handleChange
      }), /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
        handleChange: handleOtherChange,
        value: otherValue,
        placeholder: "Specify Others"
      })];
    }
    return /*#__PURE__*/_react["default"].createElement(_SearchableSelect["default"], {
      label: props.data.name,
      placeholder: props.data.config.placeholder,
      helperText: props.data.config.helpText,
      required: props.data.config.isRequired,
      labelProp: "name",
      valueProp: "id",
      options: options,
      value: value,
      handleChange: handleChange
    });
  }
}
module.exports = exports.default;