"use strict";

exports.__esModule = true;
exports["default"] = PersistentDrawerRight;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@material-ui/core/styles");
var _AppBar = _interopRequireDefault(require("@material-ui/core/AppBar"));
var _Toolbar = _interopRequireDefault(require("@material-ui/core/Toolbar"));
var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));
var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    titleCenter: {
      flexGrow: 1,
      textAlign: 'center'
    },
    titleWithAction: {
      flexGrow: 1
    },
    drawerPaper: {
      width: '32%'
    }
  };
});
function PersistentDrawerRight(props) {
  var classes = useStyles();
  (0, _react.useEffect)(function () {
    window.onscroll = function () {
      fixToolbar();
    };
  });
  var fixToolbar = function fixToolbar() {
    var header = document.getElementById("toolbar-main");
    var sticky = header.offsetTop;
    if (window.pageYOffset > sticky) {
      header.classList.add("sticky");
    } else {
      header.classList.remove("sticky");
    }
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "ahfb-toolbar-main",
    id: "toolbar-main"
  }, /*#__PURE__*/_react["default"].createElement(_AppBar["default"], {
    className: "ahfb-position-static"
  }, /*#__PURE__*/_react["default"].createElement(_Toolbar["default"], null, /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    variant: "h6",
    noWrap: true,
    className: !!props.rightIcon ? classes.titleWithAction : classes.titleCenter + " toolBarTitle"
  }, props.title, !!props.rightIcon ? /*#__PURE__*/_react["default"].createElement("span", {
    className: "ahfb-pull-right ahfb-cursor-pointer"
  }, props.rightIcon) : ""))), /*#__PURE__*/_react["default"].createElement(_Divider["default"], null), /*#__PURE__*/_react["default"].createElement("div", {
    className: props.type === 'fields' ? "ahfb-toolbar-inner-paper ahfb-toolbar-field-types" : "ahfb-toolbar-inner-paper"
  }, props.children));
}
module.exports = exports.default;