"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _reactRedux = require("react-redux");
var _TextField = _interopRequireDefault(require("./field-forms/TextField"));
var _Checkbox = _interopRequireDefault(require("./field-forms/Checkbox"));
var _Content = _interopRequireDefault(require("./field-forms/Content"));
var _Date = _interopRequireDefault(require("./field-forms/Date"));
var _File = _interopRequireDefault(require("./field-forms/File"));
var _Image = _interopRequireDefault(require("./field-forms/Image"));
var _List = _interopRequireDefault(require("./field-forms/List"));
var _Quiz = _interopRequireDefault(require("./field-forms/Quiz"));
var _Select = _interopRequireDefault(require("./field-forms/Select"));
var _Signature = _interopRequireDefault(require("./field-forms/Signature"));
var _Survey = _interopRequireDefault(require("./field-forms/Survey"));
var _Video = _interopRequireDefault(require("./field-forms/Video"));
var _Radio = _interopRequireDefault(require("./field-forms/Radio"));
var _Section = _interopRequireDefault(require("./field-forms/Section"));
var _lodash = _interopRequireDefault(require("lodash"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function EditField(props) {
  var _props$data, _props$data$editId, _props$data$editId$co, _props$allRoles;
  var field = {};
  if (props.newFieldData) {
    field = _lodash["default"].cloneDeep(props.newFieldData);
  } else {
    field = _lodash["default"].cloneDeep(props.data[props.editId]);
    if (field.locals && Object.keys(field.locals).length) Object.keys(field.locals).forEach(function (local) {
      if (local && Object.keys(local).length) field.config = _extends({}, field.config, field.locals[local]);
    });
  }
  var editId = (props == null ? void 0 : props.editId) || "83b39886-da74-4654-ae7d-e4d427082d48";
  var hiddenRoles = (props == null ? void 0 : (_props$data = props.data) == null ? void 0 : (_props$data$editId = _props$data[editId]) == null ? void 0 : (_props$data$editId$co = _props$data$editId.config) == null ? void 0 : _props$data$editId$co.hiddenRoles) || [];
  var updatedRoles = [];
  (_props$allRoles = props.allRoles) == null ? void 0 : _props$allRoles.forEach(function (role) {
    updatedRoles.push(_extends({}, role, {
      label: role == null ? void 0 : role.name,
      value: role == null ? void 0 : role.id
    }));
  });
  var renderFieldForms = function renderFieldForms() {
    switch (field.type) {
      case 'checkbox':
        return /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          data: field,
          allRoles: updatedRoles,
          hiddenRoles: hiddenRoles
        });
      case 'radio':
        return /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
          data: field,
          allRoles: updatedRoles,
          hiddenRoles: hiddenRoles
        });
      case 'content':
        return /*#__PURE__*/_react["default"].createElement(_Content["default"], {
          data: field,
          allRoles: updatedRoles,
          hiddenRoles: hiddenRoles
        });
      case 'date':
        return /*#__PURE__*/_react["default"].createElement(_Date["default"], {
          data: field,
          allRoles: updatedRoles,
          hiddenRoles: hiddenRoles
        });
      case 'file':
        return /*#__PURE__*/_react["default"].createElement(_File["default"], {
          data: field,
          allRoles: updatedRoles,
          hiddenRoles: hiddenRoles
        });
      case 'image':
        return /*#__PURE__*/_react["default"].createElement(_Image["default"], {
          data: field
        });
      case 'list':
        return /*#__PURE__*/_react["default"].createElement(_List["default"], {
          data: field
        });
      case 'quiz':
        return /*#__PURE__*/_react["default"].createElement(_Quiz["default"], {
          data: field
        });
      case 'select':
        return /*#__PURE__*/_react["default"].createElement(_Select["default"], {
          data: field,
          allRoles: updatedRoles
        });
      case 'signature':
        return /*#__PURE__*/_react["default"].createElement(_Signature["default"], {
          data: field,
          allRoles: updatedRoles,
          hiddenRoles: hiddenRoles
        });
      case 'survey':
        return /*#__PURE__*/_react["default"].createElement(_Survey["default"], {
          data: field
        });
      case 'text':
        return /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
          data: field,
          allRoles: updatedRoles,
          hiddenRoles: hiddenRoles
        });
      case 'video':
        return /*#__PURE__*/_react["default"].createElement(_Video["default"], {
          data: field
        });
      case 'section':
        return /*#__PURE__*/_react["default"].createElement(_Section["default"], {
          data: field
        });
      default:
        return /*#__PURE__*/_react["default"].createElement("div", null, "Something magical happened");
    }
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "position-relative ahfb-width-full"
  }, renderFieldForms());
}
var mapStateToProps = function mapStateToProps(state) {
  return {
    newFieldData: state.form.newFieldData,
    editId: state.toolbar.editId,
    data: state.form.data,
    allRoles: state.form.allRoles
  };
};
var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {};
};
var _default = exports["default"] = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(EditField);
module.exports = exports.default;