"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _SimpleTabs = _interopRequireDefault(require("../../../utils/Tabs/SimpleTabs"));
var _TextInput = _interopRequireDefault(require("../../../utils/inputs/TextInput"));
var _Checkbox = _interopRequireDefault(require("../../../utils/checkboxs/Checkbox"));
var _ValidateField = _interopRequireDefault(require("../../../utils/validations/ValidateField"));
var _Button = _interopRequireDefault(require("@material-ui/core/Button"));
var _toolbarActions = require("../../../actions/toolbarActions");
var _formActions = require("../../../actions/formActions");
var _reactRedux = require("react-redux");
var _dateValidation = _interopRequireDefault(require("../../../utils/date-validation"));
var _core = require("@material-ui/core");
var _richTextEditor = _interopRequireDefault(require("../../../utils/rich-text-editor"));
var _reactCustomScrollbars = require("react-custom-scrollbars");
var _SearchableSelect = _interopRequireDefault(require("../../../utils/selects/SearchableSelect"));
var _conditionalLogic = _interopRequireDefault(require("../../../utils/conditional-logic"));
var _helpers = require("../../../utils/helpers");
var _FieldRenderer = _interopRequireDefault(require("./utils/FieldRenderer"));
var _axios = _interopRequireDefault(require("axios"));
var _radioFieldConfigs = require("./utils/radioFieldConfigs");
var _dateFieldConfigs = require("./utils/dateFieldConfigs");
var _helpers2 = require("./utils/helpers");
var _EmailComplete = _interopRequireDefault(require("../../../utils/selects/EmailComplete"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == typeof h && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator["return"] && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(typeof e + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, "catch": function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function _asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var basicTabTitle = {
  en: 'Basic Settings',
  ar: 'الإعدادات الأساسية'
};
var advanceTabTitle = {
  en: 'Advance Settings',
  ar: 'إعدادات متقدمة'
};
var machineNameLabel = {
  en: 'Machine Name/Field ID',
  ar: 'إسم الألة'
};
var visibilityLabel = {
  en: 'Visibility',
  ar: 'الرؤية'
};
var cancelLabel = {
  en: 'Cancel',
  ar: 'إلغاء'
};
var saveLabel = {
  en: 'Save',
  ar: 'حفظ'
};
var visibleLabel = {
  en: 'Visible',
  ar: 'مرئي'
};
var chooseFieldHideLabel = {
  en: 'Choose Role to Hide Field',
  ar: 'اختر الدور لإخفاء الحقل'
};
var hiddenLabel = {
  en: 'Hidden',
  ar: 'مختفي'
};
var Select = /*#__PURE__*/function (_React$Component) {
  function Select(props) {
    var _this;
    _this = _React$Component.call(this, props) || this;
    _defineProperty(_this, "handleTabChange", function (e, newValue) {
      _this.setState({
        activeTab: newValue
      });
    });
    _defineProperty(_this, "handleDataChange", function (val, name) {
      var _this$setState;
      _this.setState((_this$setState = {}, _this$setState[name] = val, _this$setState.errors = {}, _this$setState));
    });
    _defineProperty(_this, "saveField", function () {
      _this.setState(_extends({}, _this.state, {
        isSaving: true
      }));
      var _this$state = _this.state,
        hiddenRoles = _this$state.hiddenRoles,
        name = _this$state.name,
        machineName = _this$state.machineName,
        order = _this$state.order,
        conditionalLogic = _this$state.conditionalLogic,
        isRequired = _this$state.isRequired,
        placeholder = _this$state.placeholder,
        helpText = _this$state.helpText,
        subType = _this$state.subType,
        visibility = _this$state.visibility,
        uuid = _this$state.uuid,
        type = _this$state.type,
        isMultiple = _this$state.isMultiple,
        shouldDateValidate = _this$state.shouldDateValidate,
        isReminder = _this$state.isReminder,
        reminderLogic = _this$state.reminderLogic,
        quantity = _this$state.quantity,
        reminderType = _this$state.reminderType,
        conditions = _this$state.conditions,
        template_html = _this$state.template_html,
        dateValidations = _this$state.dateValidations,
        parentId = _this$state.parentId;
      var newField = {
        name: name,
        machineName: machineName,
        order: order,
        uuid: uuid,
        type: type,
        parentId: parentId,
        isReminder: isReminder,
        config: {
          reminderLogic: reminderLogic,
          isReminder: isReminder,
          conditionalLogic: conditionalLogic,
          isConditionalEnabled: !!conditionalLogic.conditions.length,
          isRequired: isRequired,
          hiddenRoles: hiddenRoles,
          placeholder: placeholder,
          helpText: helpText,
          subType: subType,
          visibility: visibility,
          isMultiple: isMultiple,
          shouldDateValidate: shouldDateValidate,
          dateValidations: dateValidations
        }
      };
      var data = {
        field: newField
      };
      newField.locals = (0, _helpers2.processLocalFields)(_this.props.locals, _this.state);
      data.locals = (0, _helpers2.processLocalFields)(_this.props.locals, _this.state);
      (0, _ValidateField["default"])(newField, null, _this.props.currentLang).then(/*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _this.props.updateField(newField);
              _context.next = 3;
              return _axios["default"].post(_this.props.predefinedEndpoint + "/form/field/" + _this.props.formId, data);
            case 3:
              _this.props.disableFieldEdit();
              _this.setState(_extends({}, _this.state, {
                isSaving: false
              }));
            case 5:
            case "end":
              return _context.stop();
          }
        }, _callee);
      })))["catch"](function (errors) {
        var keys = Object.keys(errors);
        if (keys[0] === 'machineName' || keys[0] === 'conditionalLogic') {
          _this.handleTabChange({}, 'advance');
        } else {
          _this.handleTabChange({}, 'basic');
        }
        _this.setState({
          errors: errors,
          isSaving: false
        });
      });
    });
    _defineProperty(_this, "cancelEdit", function () {
      _this.props.deleteNewField();
      _this.props.disableFieldEdit();
    });
    _defineProperty(_this, "handleDateValidationChange", function (value, name, reminderLogic) {
      if (name === 'shouldDateValidate') {
        if (!value) {
          var _this$setState2;
          _this.setState((_this$setState2 = {}, _this$setState2[name] = value, _this$setState2.dateValidations = {
            pastUnit: 'days',
            pastMax: 0,
            pastMin: 0,
            futureUnit: 'days',
            futureMax: 0,
            futureMin: 0
          }, _this$setState2));
        } else {
          var _this$setState3;
          _this.setState((_this$setState3 = {}, _this$setState3[name] = value, _this$setState3));
        }
      } else {
        if (name === 'shouldPastDateValidate') {
          var _extends2;
          _this.setState({
            dateValidations: _extends({}, _this.state.dateValidations, (_extends2 = {}, _extends2[name] = value, _extends2.pastUnit = 'days', _extends2.pastMax = 0, _extends2.pastMin = 0, _extends2))
          });
        } else if (name === 'shouldFutureDateValidate') {
          var _extends3;
          _this.setState({
            dateValidations: _extends({}, _this.state.dateValidations, (_extends3 = {}, _extends3[name] = value, _extends3.futureUnit = 'days', _extends3.futureMax = 0, _extends3.futureMin = 0, _extends3))
          });
        } else {
          var _extends4;
          _this.setState({
            dateValidations: _extends({}, _this.state.dateValidations, (_extends4 = {}, _extends4[name] = value, _extends4))
          });
        }
      }
    });
    _defineProperty(_this, "handleDateValidationPut", function (reminderLogic) {
      if (reminderLogic) {
        _this.setState(_extends({}, _this.state, {
          reminderLogic: _extends({}, _this.state.reminderLogic, reminderLogic)
        }));
      }
    });
    _defineProperty(_this, "handleReminderChange", function (value, name) {
      if (name === 'isReminder') {
        var _extends5;
        _this.setState(_extends({}, _this.state, (_extends5 = {}, _extends5[name] = value, _extends5)));
      } else {
        var _extends6;
        _this.setState(_extends({}, _this.state, {
          reminderLogic: _extends({}, _this.state.reminderLogic, (_extends6 = {}, _extends6[name] = value, _extends6))
        }));
      }
    });
    _defineProperty(_this, "renderTabFields", function () {
      if (_this.state.activeTab === 'basic') {
        var _this$state$errors;
        return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_FieldRenderer["default"], _extends({}, _this.state, {
          locals: _this.props.locals,
          fieldConfigs: _dateFieldConfigs.dateFieldsConfigs,
          handleDataChange: _this.handleDataChange
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4"
        }, /*#__PURE__*/_react["default"].createElement(_dateValidation["default"], _extends({
          roles: _this.props.roles,
          predefinedEndpoint: _this.props.predefinedEndpoint,
          currentLang: _this.props.currentLang,
          errors: (_this$state$errors = _this.state.errors) == null ? void 0 : _this$state$errors.dateErrors,
          formData: _this.props.formData,
          shouldDateValidate: _this.state.shouldDateValidate,
          handleValidationChange: _this.handleDateValidationPut,
          handleChange: _this.handleDateValidationChange,
          handleReminderChange: _this.handleReminderChange
        }, _this.state.dateValidations, _this.state))));
      } else {
        return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4"
        }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
          value: _this.state.machineName,
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value, 'machineName');
          },
          label: machineNameLabel[_this.props.currentLang],
          required: true,
          autoFocus: true,
          error: _this.state.errors.machineName
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "ahfb-mt-2 ahfb-mb-2 ahfb-align-center"
        }, chooseFieldHideLabel[_this.props.currentLang]), /*#__PURE__*/_react["default"].createElement(_EmailComplete["default"], {
          onChange: function onChange(internal) {
            return _this.handleDataChange(internal, 'hiddenRoles');
          },
          internal: _this.state.hiddenRoles,
          placeholder: 'Please select roles to hide',
          data: _this.props.allRoles,
          id: "recipient",
          includeSelectAll: false
        })), /*#__PURE__*/_react["default"].createElement(_conditionalLogic["default"], {
          predefined: _this.props.predefined,
          conditionalLogic: _this.state.conditionalLogic,
          isConditionalEnabled: _this.state.isConditionalEnabled,
          handleChange: _this.handleDataChange,
          errors: _this.state.errors.conditionalLogic ? _this.state.errors.conditionalLogic : []
        }));
      }
    });
    _this.state = _extends({
      activeTab: 'basic',
      errors: {},
      uuid: props.data.uuid,
      name: props.data.name,
      type: props.data.type,
      order: props.data.order,
      parentId: props.data.parentId,
      machineName: props.data.machineName,
      isSaving: false,
      reminderLogic: props.data.reminderLogic ? props.data.reminderLogic : {
        quantity: 1,
        type: 'days',
        conditions: 'after',
        template_html: '<p>Hi <strong>%user_name%</strong>, This is a quick reminder to update you that the <strong>%field_title%</strong> it&#39;s going to expire on <strong>%date_time%</strong> But it&rsquo;s still not too late! In order to continue taking advantage of that, we will suggest you kindly update it.</p><p><br />Thank you.</p>',
        send_to: [],
        send_to_external: [],
        bcc: [],
        bcc_external: [],
        cc: [],
        cc_external: []
      },
      hiddenRoles: props.hiddenRoles
    }, props.data.config);
    return _this;
  }
  _inheritsLoose(Select, _React$Component);
  var _proto = Select.prototype;
  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (nextProps.data.uuid !== this.state.uuid) {
      this.setState(_extends({
        activeTab: 'basic',
        errors: {},
        uuid: nextProps.data.uuid,
        name: nextProps.data.name,
        type: nextProps.data.type,
        order: nextProps.data.order,
        parentId: nextProps.data.parentId,
        machineName: nextProps.data.machineName,
        isSaving: false,
        reminderLogic: nextProps.data.reminderLogic ? nextProps.data.reminderLogic : {
          quantity: 1,
          type: 'days',
          conditions: 'after',
          template_html: '<p>Hi <strong>%user_name%</strong>, This is a quick reminder to update you that the <strong>%field_title%</strong> it&#39;s going to expire on <strong>%date_time%</strong> But it&rsquo;s still not too late! In order to continue taking advantage of that, we will suggest you kindly update it.</p><p><br />Thank you.</p>',
          send_to: [],
          send_to_external: [],
          bcc: [],
          bcc_external: [],
          cc: [],
          cc_external: []
        }
      }, nextProps.data.config));

      //   if(props.data.reminderLogic){

      //   const emailObj= {
      //     send_to: props.data.reminderLogic.send_to,
      //     send_to_external: props.data.reminderLogic.send_to_external,
      //     bcc: props.data.reminderLogic.bcc,
      //     bcc_external: props.data.reminderLogic.bcc_external,
      //     cc: props.data.reminderLogic.cc,
      //     cc_external: props.data.reminderLogic.cc_external
      //   }
      //   dispatch(updateEditData(emailObj));
      // }
    }
  };
  _proto.render = function render() {
    var _this2 = this;
    return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_SimpleTabs["default"], {
      value: this.state.activeTab,
      handleChange: this.handleTabChange,
      options: [{
        label: basicTabTitle[this.props.currentLang],
        value: 'basic'
      }, {
        label: advanceTabTitle[this.props.currentLang],
        value: 'advance'
      }]
    }), /*#__PURE__*/_react["default"].createElement(_reactCustomScrollbars.Scrollbars, {
      style: {
        height: (0, _helpers.getHeight)(true, true)
      },
      autoHide: true
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-p-3 ahfb-my-3"
    }, this.renderTabFields(), /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-width-full ahfb-text-right"
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      variant: "outlined",
      className: "ahfb-mr-2",
      onClick: this.cancelEdit
    }, cancelLabel[this.props.currentLang]), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      variant: "contained",
      disableElevation: true,
      disabled: this.state.isSaving,
      onClick: function onClick() {
        _this2.handleReminderChange(_this2.template_html, 'template_html');
        _this2.saveField();
      }
    }, saveLabel[this.props.currentLang])))));
  };
  return Select;
}(_react["default"].Component);
var mapStateToProps = function mapStateToProps(state) {
  return {
    operation: state.toolbar.operation,
    predefined: state.form.predefined,
    predefinedEndpoint: state.form.predefinedEndpoint,
    roles: state.form.roles,
    formId: state.form.formId,
    formData: state.form.data,
    locals: state.form.locals,
    currentLang: state.form.currentLang
  };
};
var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    disableFieldEdit: function disableFieldEdit() {
      return dispatch((0, _toolbarActions.disableFieldEdit)());
    },
    deleteNewField: function deleteNewField() {
      return dispatch((0, _formActions.deleteNewField)());
    },
    createField: function createField(data) {
      return dispatch((0, _formActions.createField)(data));
    },
    updateField: function updateField(data) {
      return dispatch((0, _formActions.updateField)(data));
    },
    deleteField: function deleteField(id) {
      return dispatch((0, _formActions.deleteField)(id));
    }
  };
};
var _default = exports["default"] = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Select);
module.exports = exports.default;