"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _SimpleTabs = _interopRequireDefault(require("../../../utils/Tabs/SimpleTabs"));
var _TextInput = _interopRequireDefault(require("../../../utils/inputs/TextInput"));
var _Checkbox = _interopRequireDefault(require("../../../utils/checkboxs/Checkbox"));
var _SearchableSelect = _interopRequireDefault(require("../../../utils/selects/SearchableSelect"));
var _RadioGroup = _interopRequireDefault(require("../../../utils/radio/RadioGroup"));
var _ValidateField = _interopRequireDefault(require("../../../utils/validations/ValidateField"));
var _Button = _interopRequireDefault(require("@material-ui/core/Button"));
var _toolbarActions = require("../../../actions/toolbarActions");
var _formActions = require("../../../actions/formActions");
var _reactRedux = require("react-redux");
var _conditionalLogic = _interopRequireDefault(require("../../../utils/conditional-logic"));
var _reactCustomScrollbars = require("react-custom-scrollbars");
var _helpers = require("../../../utils/helpers");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var basicTabTitle = {
  en: 'Basic Settings',
  ar: 'الإعدادات الأساسية'
};
var advanceTabTitle = {
  en: 'Advance Settings',
  ar: 'إعدادات متقدمة'
};
var visibleLabel = {
  en: 'Visible',
  ar: 'مرئي'
};
var hiddenLabel = {
  en: 'Hidden',
  ar: 'مختفي'
};
var SectionField = /*#__PURE__*/function (_React$Component) {
  function SectionField(props) {
    var _this;
    _this = _React$Component.call(this, props) || this;
    _defineProperty(_this, "handleTabChange", function (e, newValue) {
      _this.setState({
        activeTab: newValue
      });
    });
    _defineProperty(_this, "handleDataChange", function (val, name) {
      var _this$setState;
      _this.setState((_this$setState = {}, _this$setState[name] = val, _this$setState.errors = {}, _this$setState));
    });
    _defineProperty(_this, "saveField", function () {
      var _this$state = _this.state,
        name = _this$state.name,
        machineName = _this$state.machineName,
        order = _this$state.order,
        conditionalLogic = _this$state.conditionalLogic,
        isConditionalEnabled = _this$state.isConditionalEnabled,
        subType = _this$state.subType,
        visibility = _this$state.visibility,
        uuid = _this$state.uuid,
        type = _this$state.type,
        collapseable = _this$state.collapseable,
        columns = _this$state.columns,
        parentId = _this$state.parentId;
      var newField = {
        name: name,
        machineName: machineName,
        order: order,
        uuid: uuid,
        type: type,
        parentId: parentId,
        config: {
          conditionalLogic: conditionalLogic,
          isConditionalEnabled: isConditionalEnabled,
          subType: subType,
          collapseable: collapseable,
          visibility: visibility,
          columns: columns
        }
      };
      (0, _ValidateField["default"])(newField, _this.props.fields, _this.props.currentLang).then(function () {
        _this.props.updateField(newField);
        _this.props.disableFieldEdit();
      })["catch"](function (errors) {
        var keys = Object.keys(errors);
        if (keys[0] === 'machineName' || keys[0] === 'conditionalLogic') {
          _this.handleTabChange({}, 'advance');
        } else {
          _this.handleTabChange({}, 'basic');
        }
        _this.setState({
          errors: errors
        });
      });
    });
    _defineProperty(_this, "cancelEdit", function () {
      _this.props.deleteNewField();
      _this.props.disableFieldEdit();
    });
    _defineProperty(_this, "renderTabFields", function () {
      if (_this.state.activeTab === 'basic') {
        return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4"
        }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
          value: _this.state.name,
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value, 'name');
          },
          label: "Section Name",
          required: true,
          autoFocus: true,
          error: _this.state.errors.name
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4"
        }, /*#__PURE__*/_react["default"].createElement(_SearchableSelect["default"], {
          disableClearable: true,
          options: [{
            label: 'Simple',
            value: 'simple'
          }, {
            label: 'Multiple',
            value: 'multiple'
          }],
          label: "SubType",
          value: _this.state.subType,
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value, 'subType');
          }
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4"
        }, /*#__PURE__*/_react["default"].createElement(_RadioGroup["default"], {
          label: "Column layout",
          options: [{
            label: '1 Column',
            value: '1'
          }, {
            label: '2 Columns',
            value: '2'
          }, {
            label: '3 Columns',
            value: '3'
          }],
          value: _this.state.columns,
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value, 'columns');
          }
        })), /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          checked: _this.state.collapseable,
          handleChange: function handleChange(val) {
            return _this.handleDataChange(val, 'collapseable');
          },
          label: "Enable Collapse"
        }));
      } else {
        return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4"
        }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
          value: _this.state.machineName,
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value, 'machineName');
          },
          label: "Machine Name/Field ID",
          required: true,
          autoFocus: true,
          error: _this.state.errors.machineName
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4"
        }, /*#__PURE__*/_react["default"].createElement(_SearchableSelect["default"], {
          options: [{
            label: visibleLabel[_this.props.currentLang],
            value: 'visible'
          }, {
            label: hiddenLabel[_this.props.currentLang],
            value: 'hidden'
          }],
          label: "Visibility",
          value: _this.state.visibility ? 'visible' : 'hidden',
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value === 'visible', 'visibility');
          }
        })), /*#__PURE__*/_react["default"].createElement(_conditionalLogic["default"], {
          predefined: _this.props.predefined,
          conditionalLogic: _this.state.conditionalLogic,
          isConditionalEnabled: _this.state.isConditionalEnabled,
          handleChange: _this.handleDataChange,
          errors: _this.state.errors.conditionalLogic ? _this.state.errors.conditionalLogic : []
        }));
      }
    });
    _this.state = _extends({
      activeTab: 'basic',
      errors: {},
      uuid: props.data.uuid,
      name: props.data.name,
      order: props.data.order,
      type: props.data.type,
      parentId: props.data.parentId,
      machineName: props.data.machineName
    }, props.data.config);
    return _this;
  }
  _inheritsLoose(SectionField, _React$Component);
  var _proto = SectionField.prototype;
  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (nextProps.data.uuid !== this.state.uuid) {
      this.setState(_extends({
        activeTab: 'basic',
        errors: {},
        uuid: nextProps.data.uuid,
        name: nextProps.data.name,
        order: nextProps.data.order,
        type: nextProps.data.type,
        parentId: nextProps.data.parentId,
        machineName: nextProps.data.machineName
      }, nextProps.data.config));
    }
  };
  _proto.render = function render() {
    return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_SimpleTabs["default"], {
      value: this.state.activeTab,
      handleChange: this.handleTabChange,
      options: [{
        label: basicTabTitle[this.props.currentLang],
        value: 'basic'
      }, {
        label: advanceTabTitle[this.props.currentLang],
        value: 'advance'
      }]
    }), /*#__PURE__*/_react["default"].createElement(_reactCustomScrollbars.Scrollbars, {
      style: {
        height: (0, _helpers.getHeight)(true, true)
      },
      autoHide: true
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-p-3 ahfb-my-3"
    }, this.renderTabFields(), /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-width-full ahfb-text-right"
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      className: "btn btn-info ahfb-mr-4",
      onClick: this.cancelEdit
    }, "Cancel"), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      className: "btn btn-primary ahfb-mr-4",
      disableElevation: true,
      onClick: this.saveField
    }, "Save")))));
  };
  return SectionField;
}(_react["default"].Component);
var mapStateToProps = function mapStateToProps(state) {
  return {
    fields: state.form.data,
    operation: state.toolbar.operation,
    predefined: state.form.predefined,
    currentLang: state.form.currentLang
  };
};
var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    disableFieldEdit: function disableFieldEdit() {
      return dispatch((0, _toolbarActions.disableFieldEdit)());
    },
    deleteNewField: function deleteNewField() {
      return dispatch((0, _formActions.deleteNewField)());
    },
    createField: function createField(data) {
      return dispatch((0, _formActions.createField)(data));
    },
    updateField: function updateField(data) {
      return dispatch((0, _formActions.updateField)(data));
    },
    deleteField: function deleteField(id) {
      return dispatch((0, _formActions.deleteField)(id));
    }
  };
};
var _default = exports["default"] = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(SectionField);
module.exports = exports.default;