"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactRedux = require("react-redux");
var _lodash = _interopRequireDefault(require("lodash"));
var _Checkbox = _interopRequireDefault(require("../checkboxs/Checkbox"));
var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));
var _Add = _interopRequireDefault(require("@material-ui/icons/Add"));
var _SearchableSelect = _interopRequireDefault(require("../selects/SearchableSelect"));
require("./style.scss");
var _ConditionItem = _interopRequireDefault(require("./ConditionItem"));
var _Button = _interopRequireDefault(require("@material-ui/core/Button"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
var conditionalLabel = {
  en: 'Enable Conditional Logic',
  ar: 'تمكين المنطق الشرطي'
};
function ConditionalLogic(props) {
  var conditionalLogic = _lodash["default"].cloneDeep(props == null ? void 0 : props.conditionalLogic);
  var singleFields = [];
  var multiFields = [];
  var textFields = [];
  var numberFields = [];
  var fields = [];
  var extractOptionsFromPredefined = function extractOptionsFromPredefined(referenceId, options) {
    if (referenceId) {
      for (var i = 0; i < props.predefined.length; i++) {
        if (props.predefined[i].id === referenceId) {
          return props.predefined[i].options;
        }
      }
    }
    return options;
  };
  var getOptions = function getOptions() {
    var options = {};
    var allFields = _extends({}, props.conditionableFields, props.data);
    _lodash["default"].map(allFields, function (field, uuid) {
      if (field.type === 'select') {
        if (field.config.isMultiple) {
          multiFields.push(field.machineName);
        } else {
          singleFields.push(field.machineName);
        }
        fields.push(field);
        if (['hiring_manager'].includes(field.machineName)) {
          var _props$users;
          options[field.machineName] = (_props$users = props.users) == null ? void 0 : _props$users.map(function (user) {
            return {
              name: user.name,
              id: user.id
            };
          });
        } else options[field.machineName] = extractOptionsFromPredefined(field.config.optionReferenceId, field.config.options);
      } else if (field.type === 'radio') {
        singleFields.push(field.machineName);
        fields.push(field);
        options[field.machineName] = options[field.machineName] = extractOptionsFromPredefined(field.config.optionReferenceId, field.config.options);
      } else if (field.type === 'checkbox') {
        multiFields.push(field.machineName);
        fields.push(field);
        options[field.machineName] = options[field.machineName] = extractOptionsFromPredefined(field.config.optionReferenceId, field.config.options);
      } else if (field.type === 'text') {
        if (field.config.subType === 'number') {
          numberFields.push(field.machineName);
          fields.push(field);
        } else {
          textFields.push(field.machineName);
          fields.push(field);
        }
      }
    });
    return options;
  };
  var _handleChange = function handleChange(val, name) {
    var _extends2;
    props.handleChange(_extends({}, props.conditionalLogic, (_extends2 = {}, _extends2[name] = val, _extends2)), 'conditionalLogic');
  };
  var enableConditionalLogic = function enableConditionalLogic(val) {
    props.handleChange(val, 'isConditionalEnabled');
    if (!val) {
      props.handleChange(_extends({}, props.conditionalLogic, {
        conditions: []
      }), 'conditionalLogic');
    }
  };
  var handleConditionChange = function handleConditionChange(val, index) {
    var _props$conditionalLog;
    var conditions = _lodash["default"].cloneDeep(props == null ? void 0 : (_props$conditionalLog = props.conditionalLogic) == null ? void 0 : _props$conditionalLog.conditions);
    conditions[index] = val;
    props.handleChange(_extends({}, props.conditionalLogic, {
      conditions: conditions
    }), 'conditionalLogic');
  };
  var addCondition = function addCondition() {
    var _props$conditionalLog2;
    var conditions = _lodash["default"].cloneDeep(props == null ? void 0 : (_props$conditionalLog2 = props.conditionalLogic) == null ? void 0 : _props$conditionalLog2.conditions);
    conditions.push({
      field: null,
      operator: '',
      value: ''
    });
    props.handleChange(_extends({}, props.conditionalLogic, {
      conditions: conditions
    }), 'conditionalLogic');
  };
  var _deleteCondition = function deleteCondition(index) {
    var _props$conditionalLog3;
    var conditions = props == null ? void 0 : (_props$conditionalLog3 = props.conditionalLogic) == null ? void 0 : _props$conditionalLog3.conditions;
    conditions.splice(index, 1);
    props.handleChange(_extends({}, props.conditionalLogic, {
      conditions: conditions
    }), 'conditionalLogic');
  };
  var renderConditions = function renderConditions() {
    var options = getOptions();
    if (conditionalLogic != null && conditionalLogic.conditions.length) {
      return conditionalLogic == null ? void 0 : conditionalLogic.conditions.map(function (condition, index) {
        var errors = props.errors[index] ? props.errors[index] : {};
        return /*#__PURE__*/_react["default"].createElement(_ConditionItem["default"], {
          key: index,
          errors: errors,
          index: index,
          handleChange: function handleChange(val) {
            return handleConditionChange(val, index);
          },
          deleteCondition: function deleteCondition(e) {
            return _deleteCondition(index);
          },
          fields: fields,
          condition: condition,
          multiFields: multiFields,
          singleFields: singleFields,
          textFields: textFields,
          numberFields: numberFields,
          options: options
        });
      });
    } else {
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "ahfb-width-full ahfb-py-3 ahfb-text-center"
      }, /*#__PURE__*/_react["default"].createElement("p", {
        className: "ahfb-text-muted"
      }, "Click below to add condition."));
    }
  };
  if (props != null && props.isConditionalEnabled) {
    var _props$conditionalLog4, _props$conditionalLog5;
    return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
      checked: props.isConditionalEnabled,
      handleChange: function handleChange(val) {
        return enableConditionalLogic(val);
      },
      label: "Enable Conditional Logic"
    })), /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-d-flow-root"
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: "ahfb-float-left ahfb-conditional-main-dropdowns ahfb-mr-1"
    }, /*#__PURE__*/_react["default"].createElement(_SearchableSelect["default"], {
      value: props == null ? void 0 : (_props$conditionalLog4 = props.conditionalLogic) == null ? void 0 : _props$conditionalLog4.display,
      handleChange: function handleChange(e) {
        return _handleChange(e.target.value, 'display');
      },
      options: [{
        label: 'Show',
        value: 'show'
      }, {
        label: 'Hide',
        value: 'hide'
      }],
      disableClearable: true
    })), /*#__PURE__*/_react["default"].createElement("span", {
      className: "ahfb-d-flex ahfb-float-left ahfb-mt-1"
    }, " this field if "), /*#__PURE__*/_react["default"].createElement("span", {
      className: "ahfb-float-left ahfb-conditional-main-dropdowns ahfb-mx-1"
    }, /*#__PURE__*/_react["default"].createElement(_SearchableSelect["default"], {
      value: props == null ? void 0 : (_props$conditionalLog5 = props.conditionalLogic) == null ? void 0 : _props$conditionalLog5.logic,
      handleChange: function handleChange(e) {
        return _handleChange(e.target.value, 'logic');
      },
      options: [{
        label: 'All',
        value: 'all'
      }, {
        label: 'Any',
        value: 'any'
      }],
      disableClearable: true
    })), /*#__PURE__*/_react["default"].createElement("span", {
      className: "ahfb-d-flex ahfb-float-left ahfb-mt-1"
    }, " of the following match:")), /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-mt-2"
    }, renderConditions(), /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-clearfix"
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      onClick: addCondition
    }, /*#__PURE__*/_react["default"].createElement(_Add["default"], null), " ", conditionalLogic != null && conditionalLogic.conditions.length ? 'Add another condition' : 'Add condition'))));
  } else {
    return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
      checked: props.isConditionalEnabled,
      handleChange: function handleChange(val) {
        return enableConditionalLogic(val);
      },
      label: conditionalLabel[props.currentLang]
    }));
  }
}
var mapStateToProps = function mapStateToProps(state) {
  return {
    data: state.form.data,
    users: state.form.users,
    conditionableFields: state.form.conditionableFields,
    currentLang: state.form.currentLang
  };
};
var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {};
};
var _default = exports["default"] = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(ConditionalLogic);
module.exports = exports.default;