"use strict";

exports.__esModule = true;
exports["default"] = EmailSelects;
var _react = _interopRequireDefault(require("react"));
var _core = require("@material-ui/core");
var _styles = require("@material-ui/core/styles");
var _EmailComplete = _interopRequireDefault(require("../../utils/selects/EmailComplete"));
var _InputLabel = _interopRequireDefault(require("@material-ui/core/InputLabel"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    labelRoot: {
      transform: 'none'
    }
  };
});
function EmailSelects(props) {
  var sendTo = props.sendTo,
    sendToExternal = props.sendToExternal,
    cc = props.cc,
    ccExternal = props.ccExternal,
    bcc = props.bcc,
    bccExternal = props.bccExternal,
    handleChange = props.handleChange,
    roles = props.roles,
    error = props.error,
    required = props.required;
  var classes = useStyles();
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "w-full"
  }, /*#__PURE__*/_react["default"].createElement(_core.FormControl, {
    className: "p-16",
    fullWidth: true
  }, /*#__PURE__*/_react["default"].createElement("label", {
    required: required,
    shrink: true,
    classes: {
      shrink: classes.labelRoot
    },
    className: "ahfb-mt-2 ahfb-mb-2 ahfb-align-center"
  }, "Recipients"), /*#__PURE__*/_react["default"].createElement(_EmailComplete["default"], {
    placeholder: 'Please select recipient(s)',
    internal: sendTo,
    external: sendToExternal,
    onChange: function onChange(internal, external) {
      return handleChange('send_to', internal, external);
    },
    data: roles,
    id: "recipient",
    includeSelectAll: false
  }), error && /*#__PURE__*/_react["default"].createElement(_core.FormHelperText, {
    error: true
  }, error)), /*#__PURE__*/_react["default"].createElement(_core.FormControl, {
    className: "p-16",
    fullWidth: true
  }, /*#__PURE__*/_react["default"].createElement("label", {
    required: required,
    shrink: true,
    classes: {
      shrink: classes.labelRoot
    },
    className: "ahfb-mt-2 ahfb-mb-2 ahfb-align-center"
  }, "CC"), /*#__PURE__*/_react["default"].createElement(_EmailComplete["default"], {
    placeholder: 'Please select cc(s)',
    internal: cc,
    external: ccExternal,
    onChange: function onChange(internal, external) {
      return handleChange('cc', internal, external);
    },
    data: roles,
    id: "cc",
    includeSelectAll: false
  })), /*#__PURE__*/_react["default"].createElement(_core.FormControl, {
    className: "p-16",
    fullWidth: true
  }, /*#__PURE__*/_react["default"].createElement("label", {
    required: required,
    shrink: true,
    classes: {
      shrink: classes.labelRoot
    },
    className: "ahfb-mt-2 ahfb-mb-2 ahfb-align-center"
  }, "BCC"), /*#__PURE__*/_react["default"].createElement(_EmailComplete["default"], {
    placeholder: 'Please select bcc(s)',
    internal: bcc,
    external: bccExternal,
    onChange: function onChange(internal, external) {
      return handleChange('bcc', internal, external);
    },
    data: roles,
    id: "cc",
    includeSelectAll: false
  })));
}
module.exports = exports.default;