"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _Checkbox = _interopRequireDefault(require("../checkboxs/Checkbox"));
var _SearchableSelect = _interopRequireDefault(require("../selects/SearchableSelect"));
var _EmailSelects = _interopRequireDefault(require("../../utils/date-validation/EmailSelects"));
var _TextInput = _interopRequireDefault(require("../inputs/TextInput"));
var _styles = require("@material-ui/core/styles");
var _richTextEditor = _interopRequireDefault(require("../../utils/rich-text-editor"));
var _core = require("@material-ui/core");
var _formActions = require("../../actions/formActions");
var _reactRedux = require("react-redux");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
var dateValidationLabel = {
  en: 'Set Date Validation',
  ar: 'تحديد تاريخ التحقق من الصحة'
};
var reminderNotificationLabel = {
  en: 'Set Reminder/Notification',
  ar: 'تعيين تذكير / إعلام'
};
var reminderNotificationEmailLabel = {
  en: 'Reminder/Notification Email',
  ar: 'بريد إلكتروني للتذكير / الإخطار'
};
var emailSentUserParameter = {
  en: 'Email sent to users based on set parameters.',
  ar: 'تم إرسال البريد الإلكتروني إلى المستخدمين بناءً على المعلمات المحددة.'
};
var PLEASE_SELECT_RECIPIENTS = {
  en: 'Recipients ',
  ar: 'المستلمون'
};
var PLEASE_SELECT_CC = {
  en: 'CC',
  ar: 'نسخة'
};
var PLEASE_SELECT_BCC = {
  en: 'BCC',
  ar: 'نسخة مخفية الوجهة'
};
var setPastDateLabel = {
  en: 'Set Past Date',
  ar: 'تعيين التاريخ الماضي'
};
var setFutureDateLabel = {
  en: 'Set Future Date',
  ar: 'تحديد موعد في المستقبل'
};
var unitLabel = {
  en: 'Unit',
  ar: 'وحدة'
};
var minLabel = {
  en: 'Min',
  ar: 'دقيقة'
};
var maxLabel = {
  en: 'Max',
  ar: 'الأعلى'
};
var dayLabel = {
  en: 'Days',
  ar: 'أيام'
};
var monthLabel = {
  en: 'Months',
  ar: 'الشهور'
};
var yearLabel = {
  en: 'Years',
  ar: 'سنوات'
};
var afterDateLabel = {
  en: 'After Selected Date',
  ar: 'بعد التاريخ المحدد'
};
var beforeDateLabel = {
  en: 'Before Selected Date',
  ar: 'قبل التاريخ المحدد'
};
var cancelLabel = {
  en: 'Cancel',
  ar: 'إلغاء'
};
var updateLabel = {
  en: 'Update',
  ar: 'تحديث'
};
var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    ahfb_para_st: {
      fontSize: '1.4rem !important',
      fontFamily: "\"Roboto\", \"Helvetica\", \"Arial\", sans-serif",
      fontWeight: '700 !important',
      lineHeight: '1.5 !important',
      letterSpacing: '0.00938em !important',
      paddingTop: '18px'
    },
    ahfb_para_st_email: {
      fontSize: '1.4rem !important',
      fontFamily: "\"Roboto\", \"Helvetica\", \"Arial\", sans-serif",
      fontWeight: '400 !important',
      lineHeight: '1.5 !important',
      letterSpacing: '0.00938em !important',
      marginTop: '-5px'
    },
    ahfb_editor_st: {
      top: '25% !important',
      left: '30% !important',
      width: '40% !important',
      position: 'absolute !important'
    },
    ahfb_editor_box: {
      background: '#fff',
      padding: '25px 25px 70px 25px',
      borderRadius: '8px'
    },
    ahfb_editor_btn_box: {
      "float": 'right'
    },
    ahfb_btn_primary: {
      color: '#3f51b5',
      border: '1px solid rgba(63, 81, 181, 0.5)',
      background: 'white',
      padding: '8px 20px',
      borderRadius: '4px',
      marginTop: '15px',
      marginRight: '0.5rem !important'
    },
    ahfb_btn_secondary: {
      color: '#fff',
      border: '1px solid rgba(63, 81, 181, 0.5)',
      background: '#3f51b5',
      padding: '8px 20px',
      borderRadius: '4px',
      marginTop: '15px',
      marginRight: '0.5rem !important'
    },
    ahfb_emails_st: {
      marginTop: '12px !important',
      marginBottom: '12px !important'
    }
  };
});
function DateValidation(props) {
  var _props$errors, _props$errors$pastLim, _props$errors2, _props$errors2$pastLi, _props$errors3, _props$errors3$future, _props$errors4, _props$errors4$future;
  var classes = useStyles();
  var _React$useState = _react["default"].useState(null),
    anchorEl = _React$useState[0],
    setAnchorEl = _React$useState[1];
  var sendTo = props.sendTo,
    sendToExternal = props.sendToExternal,
    cc = props.cc,
    ccExternal = props.ccExternal,
    bcc = props.bcc,
    bccExternal = props.bccExternal,
    handleValidationChange = props.handleValidationChange,
    roles = props.roles,
    error = props.error,
    formData = props.formData;
  var open = Boolean(anchorEl);
  var id = open ? 'simple-popper' : undefined;
  var updatedRoles = [];
  roles == null ? void 0 : roles.forEach(function (role) {
    updatedRoles.push(_extends({}, role, {
      label: role == null ? void 0 : role.name,
      value: role == null ? void 0 : role.id
    }));
  });
  var durationOptions = [{
    label: dayLabel[props.currentLang],
    value: 'days'
  }, {
    label: monthLabel[props.currentLang],
    value: 'months'
  }, {
    label: yearLabel[props.currentLang],
    value: 'years'
  }];
  var selectedDateOptions = [{
    label: afterDateLabel[props.currentLang],
    value: 'after'
  }, {
    label: beforeDateLabel[props.currentLang],
    value: 'before'
  }];
  var _React$useState2 = _react["default"].useState(false),
    opens = _React$useState2[0],
    setOpens = _React$useState2[1];
  var handleEditor = function handleEditor() {
    return setOpens(!opens);
  };
  var editedData = (0, _reactRedux.useSelector)(function (state) {
    return state.form.editData;
  });
  var editId = (0, _reactRedux.useSelector)(function (state) {
    return state.toolbar.editId;
  });
  (0, _react.useEffect)(function () {
    if (editId) {
      var emailData = formData[editId].config.reminderLogic;
      dispatch((0, _formActions.updateEditData)(emailData));
    } else {
      dispatch((0, _formActions.updateEditData)({
        send_to: [],
        send_to_external: [],
        bcc: [],
        bcc_external: [],
        cc: [],
        cc_external: []
      }));
    }
  }, [dispatch, editId]);
  var getEditData = function getEditData() {
    if (Object.values(formData)[0]) {
      var _Object$values$, _Object$values$$confi;
      return (_Object$values$ = Object.values(formData)[0]) == null ? void 0 : (_Object$values$$confi = _Object$values$.config) == null ? void 0 : _Object$values$$confi.reminderLogic;
    } else {
      return editedData;
    }
  };
  var editData = editedData;
  var dispatch = (0, _reactRedux.useDispatch)();
  var handleEmailsChange = function handleEmailsChange(name, internal, external) {
    var allData = _extends({
      send_to: [],
      send_to_external: [],
      cc: [],
      cc_external: [],
      bcc: [],
      bcc_external: []
    }, editData);
    if (name === 'send_to') {
      var newState = _extends({}, editData, {
        send_to: internal,
        send_to_external: external
      });
      allData.send_to = internal;
      allData.send_to_external = external;
      dispatch((0, _formActions.updateEditData)(newState));
    } else if (name === 'cc') {
      var _newState = _extends({}, editData, {
        cc: internal,
        cc_external: external
      });
      allData.cc = internal;
      allData.cc_external = external;
      dispatch((0, _formActions.updateEditData)(_newState));
    } else if (name === 'bcc') {
      var _newState2 = _extends({}, editData, {
        bcc: internal,
        bcc_external: external
      });
      allData.bcc = internal;
      allData.bcc_external = external;
      dispatch((0, _formActions.updateEditData)(_newState2));
    }
    handleValidationChange(allData);
  };
  return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("row", null, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
    checked: props.shouldDateValidate,
    handleChange: function handleChange(val) {
      return props.handleChange(val, 'shouldDateValidate');
    },
    label: dateValidationLabel[props.currentLang]
  }), props.shouldDateValidate ? /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    container: true
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 12,
    className: "mb-2"
  }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
    checked: props.shouldPastDateValidate,
    handleChange: function handleChange(val) {
      return props.handleChange(val, 'shouldPastDateValidate');
    },
    label: setPastDateLabel[props.currentLang]
  })), props.shouldPastDateValidate && /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    container: true,
    spacing: 3,
    className: "mt-4"
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 12
  }, /*#__PURE__*/_react["default"].createElement(_SearchableSelect["default"], {
    label: unitLabel[props.currentLang],
    options: durationOptions,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'pastUnit');
    },
    value: props.pastUnit
  })), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 12,
    container: true
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 6,
    className: "ahfb-pr-1"
  }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
    type: "number",
    label: minLabel[props.currentLang],
    value: props.pastMin,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'pastMin');
    },
    error: (_props$errors = props.errors) == null ? void 0 : (_props$errors$pastLim = _props$errors.pastLimitValidation) == null ? void 0 : _props$errors$pastLim.min
  })), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 6,
    className: "ahfb-pl-1"
  }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
    type: "number",
    label: maxLabel[props.currentLang],
    value: props.pastMax,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'pastMax');
    },
    error: (_props$errors2 = props.errors) == null ? void 0 : (_props$errors2$pastLi = _props$errors2.pastLimitValidation) == null ? void 0 : _props$errors2$pastLi.max
  })))), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 12,
    className: "mb-2"
  }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
    checked: props.shouldFutureDateValidate,
    handleChange: function handleChange(val) {
      return props.handleChange(val, 'shouldFutureDateValidate');
    },
    label: setFutureDateLabel[props.currentLang]
  })), props.shouldFutureDateValidate && /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    container: true,
    spacing: 3,
    className: "mt-4"
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 12
  }, /*#__PURE__*/_react["default"].createElement(_SearchableSelect["default"], {
    label: unitLabel[props.currentLang],
    options: durationOptions,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'futureUnit');
    },
    value: props.futureUnit
  })), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 12,
    container: true
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 6,
    className: "ahfb-pr-1"
  }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
    type: "number",
    label: minLabel[props.currentLang],
    value: props.futureMin,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'futureMin');
    },
    error: (_props$errors3 = props.errors) == null ? void 0 : (_props$errors3$future = _props$errors3.futureLimitValidation) == null ? void 0 : _props$errors3$future.min
  })), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 6,
    className: "ahfb-pl-1"
  }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
    type: "number",
    label: maxLabel[props.currentLang],
    value: props.futureMax,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'futureMax');
    },
    error: (_props$errors4 = props.errors) == null ? void 0 : (_props$errors4$future = _props$errors4.futureLimitValidation) == null ? void 0 : _props$errors4$future.max
  }))))) : ""), /*#__PURE__*/_react["default"].createElement("br", null), /*#__PURE__*/_react["default"].createElement("row", null, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
    checked: props == null ? void 0 : props.isReminder,
    handleChange: function handleChange(val) {
      return props == null ? void 0 : props.handleReminderChange(val == true ? 1 : 0, 'isReminder');
    },
    label: reminderNotificationLabel[props == null ? void 0 : props.currentLang]
  }), props.isReminder ? /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    container: true
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    container: true,
    className: classes.ahfb_emails_st
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    xs: 12
  }, /*#__PURE__*/_react["default"].createElement(_EmailSelects["default"], {
    sendTo: editData.send_to,
    sendToExternal: editData.send_to_external,
    cc: editData.cc,
    ccExternal: editData.cc_external,
    bcc: editData.bcc,
    bccExternal: editData.bcc_external,
    handleChange: handleEmailsChange,
    errors: props.errors,
    roles: updatedRoles,
    error: props.errors.send_to
  }))), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    container: true,
    spacing: 3,
    className: "mt-4"
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 12,
    container: true
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 3,
    className: "ahfb-pr-1"
  }, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
    type: 'text',
    handleChange: function handleChange(e) {
      return props.handleReminderChange(Number.isInteger(parseInt(e.target.value)) ? e.target.value : '', 'quantity');
    },
    value: props.reminderLogic.quantity,
    inputProps: {
      maxLength: 3
    }
  }))), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 4,
    className: "ahfb-pr-1"
  }, /*#__PURE__*/_react["default"].createElement(_SearchableSelect["default"], {
    options: durationOptions,
    handleChange: function handleChange(e) {
      var _e$target;
      return props.handleReminderChange(e == null ? void 0 : (_e$target = e.target) == null ? void 0 : _e$target.value, 'type');
    },
    value: props.reminderLogic.type
  })), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 5,
    className: "ahfb-pl-1"
  }, /*#__PURE__*/_react["default"].createElement(_SearchableSelect["default"], {
    options: selectedDateOptions,
    handleChange: function handleChange(e) {
      var _e$target2;
      return props.handleReminderChange(e == null ? void 0 : (_e$target2 = e.target) == null ? void 0 : _e$target2.value, 'conditions');
    },
    value: props.reminderLogic.conditions
  }), "  "))), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 12,
    container: true
  }, /*#__PURE__*/_react["default"].createElement("label", {
    className: "ahfb-mt-3 ahfb-align-center"
  }, reminderNotificationEmailLabel[props.currentLang], /*#__PURE__*/_react["default"].createElement("svg", {
    onClick: handleEditor,
    "class": "MuiSvgIcon-root MuiSvgIcon-colorAction MuiSvgIcon-fontSizeSmall text-inline",
    focusable: "false",
    viewBox: "0 0 24 24",
    "aria-hidden": "true"
  }, /*#__PURE__*/_react["default"].createElement("path", {
    d: "M3 17.25V21h3.75L17.81 9.94l-3.75-3.75L3 17.25zM20.71 7.04c.39-.39.39-1.02 0-1.41l-2.34-2.34a.9959.9959 0 00-1.41 0l-1.83 1.83 3.75 3.75 1.83-1.83z"
  })))), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 12,
    container: true
  }, /*#__PURE__*/_react["default"].createElement("label", {
    className: "ahfb-mt-2 ahfb-mb-2 ahfb-align-center"
  }, emailSentUserParameter[props.currentLang]), /*#__PURE__*/_react["default"].createElement("div", {
    style: opens ? {
      display: 'block'
    } : {
      display: 'none'
    }
  }, /*#__PURE__*/_react["default"].createElement(_richTextEditor["default"], {
    data: props.reminderLogic.template_html,
    handleChange: function handleChange(data) {
      return props.handleReminderChange(data, 'template_html');
    }
  })))) : ""));
}
var _default = exports["default"] = DateValidation;
module.exports = exports.default;