"use strict";

exports.__esModule = true;
exports["default"] = NewOption;
var _react = _interopRequireWildcard(require("react"));
var _TextInput = _interopRequireDefault(require("../inputs/TextInput"));
var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));
var _Done = _interopRequireDefault(require("@material-ui/icons/Done"));
var _helpers = require("../helpers");
var _core = require("@material-ui/core");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function NewOption(props) {
  var _React$useState = _react["default"].useState(''),
    name = _React$useState[0],
    setName = _React$useState[1];
  var _React$useState2 = _react["default"].useState(''),
    value = _React$useState2[0],
    setValue = _React$useState2[1];
  var _React$useState3 = _react["default"].useState(''),
    updated = _React$useState3[0],
    setUpdated = _React$useState3[1];
  var _React$useState4 = _react["default"].useState(''),
    error = _React$useState4[0],
    setError = _React$useState4[1];
  var inputRef = (0, _react.useRef)();
  (0, _react.useEffect)(function () {
    var _inputRef$current;
    inputRef == null ? void 0 : (_inputRef$current = inputRef.current) == null ? void 0 : _inputRef$current.focus();
  }, []);
  var handleNameChange = function handleNameChange(e) {
    setError('');
    setName(e.target.value);
  };
  var handleValueChange = function handleValueChange(e) {
    setError('');
    setValue(e.target.value);
  };
  var saveNewOption = function saveNewOption(e) {
    var _inputRef$current2;
    e.preventDefault();
    var values = [];
    var properValue = value;
    if (!value || value === '') {
      properValue = (0, _helpers.stringToSlug)(name);
    }
    props.options.map(function (option) {
      var _option$name;
      values.push(option == null ? void 0 : (_option$name = option.name) == null ? void 0 : _option$name.toLowerCase());
    });
    if (values.includes(name == null ? void 0 : name.toLowerCase())) {
      setError('Category with same name already exists.');
    } else {
      props.saveNewCategoryOption(name, properValue);
      setName('');
      setValue('');
    }
    inputRef == null ? void 0 : (_inputRef$current2 = inputRef.current) == null ? void 0 : _inputRef$current2.focus();
  };
  return /*#__PURE__*/_react["default"].createElement("form", {
    onSubmit: saveNewOption
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    container: true,
    className: "ahfb-pl-3"
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 6
  }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
    inputProps: {
      ref: inputRef
    },
    placeholder: "Name",
    value: name,
    handleChange: handleNameChange,
    error: error
  })), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    className: "ahfb-pl-2",
    item: true,
    xs: 6
  }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
    placeholder: "Value",
    value: value,
    handleChange: handleValueChange
  }))), /*#__PURE__*/_react["default"].createElement("button", {
    className: "ahfb-hidden",
    type: "submit"
  }, "Submit"));
}
module.exports = exports.default;