"use strict";

exports.__esModule = true;
exports["default"] = MultiSelect;
var _react = _interopRequireDefault(require("react"));
var _TextField = _interopRequireDefault(require("@material-ui/core/TextField"));
var _Autocomplete = _interopRequireDefault(require("@material-ui/lab/Autocomplete"));
var _Checkbox = _interopRequireDefault(require("@material-ui/core/Checkbox"));
var _styles = require("@material-ui/core/styles");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    labelRoot: {
      transform: 'none'
    }
  };
});
function MultiSelect(props) {
  var classes = useStyles();
  var options = props.options,
    value = props.value,
    handleChange = props.handleChange,
    label = props.label,
    error = props.error,
    required = props.required,
    placeholder = props.placeholder,
    helperText = props.helperText,
    disabled = props.disabled;
  var labelProp = props.labelProp ? props.labelProp : 'label';
  var valueProp = props.valueProp ? props.valueProp : 'value';
  var values = [];
  if (value.length) {
    options.map(function (option) {
      if (value.includes(option[valueProp])) {
        values.push(option);
      }
    });
  }
  return /*#__PURE__*/_react["default"].createElement(_Autocomplete["default"], {
    multiple: true,
    options: options,
    getOptionLabel: function getOptionLabel(option) {
      return option[labelProp];
    },
    value: values,
    disabled: disabled,
    disableCloseOnSelect: true,
    onChange: function onChange(event, newValue) {
      handleChange({
        target: {
          value: newValue.map(function (item) {
            return item[valueProp];
          })
        }
      });
    },
    renderOption: function renderOption(option) {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
        checked: value && Array.isArray(value) && value.includes(option[valueProp])
      }), option[labelProp]);
    },
    renderInput: function renderInput(params) {
      return /*#__PURE__*/_react["default"].createElement(_TextField["default"], _extends({}, params, {
        required: required,
        placeholder: value.length ? "" : placeholder,
        InputLabelProps: {
          shrink: true,
          classes: {
            shrink: classes.labelRoot
          }
        },
        label: label,
        error: !!error,
        helperText: error ? error : helperText ? helperText : null
      }));
    }
  });
}
module.exports = exports.default;