"use strict";

exports.__esModule = true;
exports["default"] = SearchableSelect;
var _react = _interopRequireDefault(require("react"));
var _TextField = _interopRequireDefault(require("@material-ui/core/TextField"));
var _Autocomplete = _interopRequireDefault(require("@material-ui/lab/Autocomplete"));
var _FormLabel = _interopRequireDefault(require("@material-ui/core/FormLabel"));
var _styles = require("@material-ui/core/styles");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    labelRoot: {
      transform: 'none'
    }
  };
});
function SearchableSelect(props) {
  var classes = useStyles();
  var options = props.options,
    value = props.value,
    handleChange = props.handleChange,
    label = props.label,
    error = props.error,
    required = props.required,
    placeholder = props.placeholder,
    helperText = props.helperText,
    disabled = props.disabled,
    disableClearable = props.disableClearable;
  var labelProp = props.labelProp ? props.labelProp : 'label';
  var valueProp = props.valueProp ? props.valueProp : 'value';
  var formattedValue = null;
  for (var i = 0; i < options.length; i++) {
    if (options[i][valueProp] === value) {
      formattedValue = options[i];
    }
  }
  return /*#__PURE__*/_react["default"].createElement(_Autocomplete["default"], {
    disablePortal: true,
    value: formattedValue,
    options: options,
    disabled: disabled,
    getOptionLabel: function getOptionLabel(option) {
      return option[labelProp];
    },
    onChange: function onChange(e, value) {
      handleChange({
        target: {
          value: value[valueProp]
        }
      });
    },
    disableClearable: disableClearable,
    renderInput: function renderInput(params) {
      return /*#__PURE__*/_react["default"].createElement(_TextField["default"], _extends({}, params, {
        required: required,
        placeholder: value ? "" : placeholder,
        InputLabelProps: {
          shrink: true,
          classes: {
            shrink: classes.labelRoot
          }
        },
        label: label,
        error: !!error,
        helperText: error ? error : helperText ? helperText : null
      }));
    }
  });
}
module.exports = exports.default;